/**
 * 按图片姿势拍照确认(上传大头照)
 */
define(function(require,exports,module){

	var appUtils 	  = require("appUtils"),
		layerUtils    = require("layerUtils"),
		external      = require("external"),
		service       = require("serviceImp").getInstance(),  //业务层接口，请求数据
		global        = require("gconfig").global,
		IS_WX         = global.isWX,
		IS_SDK        = global.is_sdk,
		_pageId       = "#account_backPostConfirm";

	var	UPLOAD_FLAG   = 0,	                           //用于判定是否需要校验图片上传 0 （校验）1（不校验）
		FAIL_COUNT,                                    //人脸识别失败次数 。 大于三次建议qq视频见证。
		WEIXIN_PK,
		OPEN_ID,
		USER_ID,
		JSESSIONID,
		CLIENT_INFO,
		MOBILE_NO,
		ID_CARD_NO,
		CUST_NAME,
		REJECT_STEP,
        REJECT_INFO;

	require("makeThumb");


	function init(){

		FAIL_COUNT    = 0;
		WEIXIN_PK     = appUtils.getSStorageInfo("weixinpk");
		OPEN_ID       = appUtils.getSStorageInfo("openid");
		USER_ID       = appUtils.getSStorageInfo("user_id");
		JSESSIONID    = appUtils.getSStorageInfo("jsessionid");
		CLIENT_INFO   = appUtils.getSStorageInfo("clientinfo");
		MOBILE_NO     = appUtils.getSStorageInfo("mobileNo");
		ID_CARD_NO    = appUtils.getSStorageInfo("idCardNo");
		CUST_NAME     = appUtils.getSStorageInfo("custname");
		REJECT_STEP   = appUtils.getSStorageInfo("rejectStep");
        REJECT_INFO   = appUtils.getSStorageInfo("rejectInfo");

        var $reason       =  $(_pageId+' .reject-tips');
        showRejectReason($reason,['video']);
        $reason.fadeIn();
        $reason.on('click',function(){
            $(this).fadeOut();
        });
	}


	function bindPageEvent(){

		var $next      = $(_pageId+" .btn-next-step"),
			$show_demo = $(_pageId+" .show-demo");

		appUtils.bindEvent($next,function(e){

            if(IS_SDK){ //sdk上传
                showShellUploadOption({
                     img_type:3
                });
                return;
            }

            if(IS_WX){//微信上传
                uploadPhotoByWeixin();
                return;
            }

			$('#btn-upload-post').remove();
			$(_pageId).append('<input type="file" accept="image/*,camera" capture="camera"  id="btn-upload-post" style="width:0px;height:0px;opacity:0;position:absolute;top:0;left:0;"/>');
		    $('#btn-upload-post').makeThumb({
		    	width:500,
		    	height:500,
				immediate:false,
		        success: uploadPost,
				error: function(obj,state){
					if(state === 10){
						layerUtils.iAlert("不能选取相册中的照片！");
						return false;
					}
				}
		    });
		    $('#btn-upload-post').trigger('click');
		});

		//示例
        appUtils.bindEvent($show_demo,function(e){
            e.preventDefault();
            var demo_str = '<div class="overlay demo-ovarlay">'+
                                '<div class="info-window">'+
                                    '<div class="pic-demo"><img src="images/head_demo.png" width="100%" height="auto" alt=""></div>'+
                                    '<div class="info-window-btn">我知道了</div>'+
                                '</div>'+
                            '</div>';
            $(_pageId).append(demo_str);
        });

        appUtils.preBindEvent(_pageId,'.info-window-btn',function(){
            $(_pageId+' .demo-ovarlay').remove();
        });

        //用相机拍照
        appUtils.preBindEvent(_pageId,'.btn-camera',function(){
            console.log('使用相机拍照...');
            var img_type = $(_pageId+' .select-list').attr('data-img-type');
            $(_pageId+' .select-overlay').remove();

            uploadPhotoByShell({
                img_type:img_type,
                action:'pai'
            })
        });

        //从相册选择
        appUtils.preBindEvent(_pageId,'.btn-album',function(){
            console.log('从相册选择...');
            var img_type = $(_pageId+' .select-list').attr('data-img-type');
            $(_pageId+' .select-overlay').remove();

            uploadPhotoByShell({
                img_type:img_type,
                action:'phone'
            })
        });

        //关闭 选择照片\相册 （原生）
        appUtils.preBindEvent(_pageId,'.select-cancel-btn',function(){
            $(_pageId+' .select-list').removeClass('active');

            setTimeout(function(){
                $(_pageId+' .select-overlay').remove();
            },200);
        });
	}


    /**
     * [showShellUploadOption 显示调用原生壳子的下拉选单]
     */
    function showShellUploadOption(opt){
        var html_str = ' <div class="overlay select-overlay">\
                           <div class="select-list" data-img-type="'+opt.img_type+'">\
                               <div class="select-item btn-camera">拍照</div>\
                               <div class="select-item btn-album">从相册选择</div>\
                               <div class="select-cancel-btn">取消</div>\
                           </div>\
                        </div>';

        $(_pageId).append(html_str);

        setTimeout(function(){
            $(_pageId+' .select-list').addClass('active');
        },0);
    }


    /**
     * imgState 供原生上传返回调用
     */
	function imgState(data){
		faceRecognition();
	}


	/**
	 * [uploadPost 上传图片]
	 * @param  {[type]} dataURL 图片数据base64编码
	 * @param  {[type]} tSize   [description]
	 * @param  {[type]} file    [description]
	 * @param  {[type]} sSize   [description]
	 * @param  {[type]} fEvt    [description]
	 * @return {[type]}         [description]
	 */
	function uploadPost(dataURL, tSize, file, sSize, fEvt) {

	    $(_pageId + " .post-pic").attr("src", dataURL);

	    // 图片上传至服务器
	    var img_data = dataURL.split(",")[1];
	    var param = {
	        "user_id"        : USER_ID,
	        "img_data"       : img_data,
	        "img_type"       : "3",
	        "jsessionid"     : JSESSIONID,
	        "opacctkind_flag": "1"
	    };
	    service.uploadHeadImg(param, function(data) {
	        var error_no = data.error_no;
	        var error_info = data.error_info;
	        if (error_no == 0) {
	            faceRecognition(); //人脸识别
	        } else {
	            layerUtils.iAlert(error_info);
	            layerUtils.iLoading(false);
	        }
	    }, true, false);
	}

	/**
	 * faceRecognition 人脸识别
	 */
	function faceRecognition() {
	    var param = {
	        "user_id"  : USER_ID,
	        "mobile_no": MOBILE_NO,
	        "id_no"    : ID_CARD_NO,
	        "user_name": CUST_NAME
	    }
	    service.faceRecognition(param, function(data) {
	    	layerUtils.iLoading(false);
	        FAIL_COUNT++;
	        if (data.error_no == 0) {
	            var pass_flag = data.results[0].pass_flag;
	            if ("1" == pass_flag) {
					appUtils.pageInit("account/backPostConfirm", "account/videoRecord");
	            } else {
	                layerUtils.iAlert("人脸识别失败，请重新拍照识别！", -1, function() {}, "重新拍照");
	            }
	        } else {
	            layerUtils.iAlert("人脸识别失败，请重新拍照识别！", -1, function() {}, "重新拍照");
	        }
	    });
	}


    /**
     * [uploadPhotoByShell 调用shell上传]
     * @param  {[type]} opt [description]
     * @return {[type]}     [description]
     */
    function uploadPhotoByShell(opt){
        var param = {
            "funcNum"    : "501526",
            "uuid"       : "index",
            "r"          : Math.random(),
            "userId"     : USER_ID,
            "photoType"  : "人像正面",      // 影像名称
            "action"     : opt.action,   // 照片来源类别，phone-相册，pai-相机
            "imgType"    : opt.img_type,
            "key"        : "index",      // key 和 uuid 只需要写一个
            "url"        : global.serverPath,
            "clientInfo" : CLIENT_INFO, // 从 session 中将 clientinfo 取出
            "jsessionId" : JSESSIONID,  // 从 session 中将 jsessionid 取出
            "funcNo"     : "60002",
            "moduleName" : "open"
        };
        external.callMessage(param);
    }


	/*
     * 通过微信SDK上传图片
     * 大头照，姿势识别照需要检测图片来源，相册图片不予上传
     * 参数集合需要包含相应图片上传方法的接口号，不需要包含图片base64数据
     */
	function uploadPhotoByWeixin() {
	    var param = {
	        //为避免与微信SDK接口号冲突，BUS接口号参数名必须为"func_No"
	        "func_No"     : "501526",
	        "user_id"     : USER_ID,
	        "jsessionid"  : JSESSIONID,
	        "img_type"    : "3",
	        "count"       : 1, //限制选择多少张照片
	        "sizeType"    : ['original', 'compressed'], //压缩类型
	        "sourceType"  : ['camera'], //可以选择相册或拍照，需要升级jweixin.js
	        "isNeedCamera": false
	    };
	    var uploadComplate = function(data) {
	            // 返回选定照片的本地ID列表，localId可以作为img标签的src属性显示图片
	            if (data.isNeedCamera && (data.sourceType.indexOf(camera) > -1 && data.sourceType > 0)) {
	                layerUtils.iAlert("请使用相机拍摄照片");
	                return false;
	            } else if (data.localIds.length > 1) {
	                layerUtils.iAlert("请仅上传一张图片");
	                return false;
	            } else if (data.localIds.length == 0) {
	                layerUtils.iAlert("请上传一张图片");
	                return false;
	            }
	            $(_pageId + " .pose_img").attr("src", data.localIds[0]);
	            layerUtils.iLoading(true);
	            return true
	        }
	        //免冠照上传后的回调
	    var hasUploadHeadPhoto = function(data) {
	        if (data.error_no === "0") {
	            faceRecognition(); //人脸识别
	        } else {
	            layerUtils.iLoading(false);
	            layerUtils.iAlert(data.error_info);
	        }
	    }
	    var uploadFail = function(data) {
	        layerUtils.iLoading(false);
	        if (data.err_no == -1) {
	            layerUtils.iAlert("选择图片失败，请重试！");
	        } else {
	            layerUtils.iAlert("上传失败,原因：" + JSON.stringify(data));
	        }
	    }
	    utils.uploadPhotoByWeixin(param, uploadComplate, hasUploadHeadPhoto, uploadFail);
	}

    /**
     * [showRejectReason 提示驳回原因]
     * @param  {[type]} $dom 需要填充的位置
     * @param  {[type]} arr  本步骤涉及到的驳回字段
     *
     */
    function showRejectReason($dom,arr){

        var $reason       =  $(_pageId+' .photo-back-reason'),
            resons        =  JSON.parse(REJECT_INFO),
            currentReason = [],
            html_str      ="";

        //遍历出当前步骤驳回的原因
        for(var i = 0;i<resons.length;i++){
            if(arr.indexOf(resons[i]['fieldenname'])>-1){
                currentReason.push(resons[i]);
            }
        }

        //拼接提示字符串
        for(var j = 0;j<currentReason.length;j++){
            html_str+='<p><strong>'+currentReason[j]['fielddesc']+'</strong> '+currentReason[j]['rejreason']+'</p>';
        }

        $dom.html(html_str);
    }


	function destroy(){
		service.destroy();//销毁服务
	}

	module.exports = {
		"init" : init,
		"bindPageEvent" : bindPageEvent,
		"imgState"     : imgState,
		"destroy" : destroy
	};
});
