/**
 * 签署协议
 */
define(function(require, exports, module){ 
	/* 私有业务模块的全局变量 begin */
	var appUtils = require("appUtils"),
	    service = require("serviceImp").getInstance(),  //业务层接口，请求数据
		global = require("gconfig").global,
		layerUtils = require("layerUtils"),
		utils = require("utils"),
		Map = require("map"),
		fristMap = null,  //  存放所有相关协议
	    protocolArray = new Array(),  // 存放协议签名值
		isClose = true,  // 用于控制等待层
		countProtocol = 0, // 计算签署成功的数量
		userId = null,
	    cert_type = appUtils.getSStorageInfo("openChannel") == "new" ? "zd" : "tw", // tw:天威 zd:中登
	    protocol = null,  // 协议保存
	    _pageId = "#account_backSignProtocol";
	/* 私有业务模块的全局变量 end */
	
	function init()
	{
		userId = appUtils.getSStorageInfo("user_id");
		cert_type = appUtils.getSStorageInfo("openChannel") == "new" ? "zd" : "tw"; // tw:天威 zd:中登
		var jsonBankArray = new Array();
		jsonBankArray = ["1","2"];
		getMarket();
		getAgreement(jsonBankArray);
	}
	
	/* 获取市场列表 */
	function getMarket()
	{
		// 获取开通证券账户枚举
		var allOpenAccountStr = ""; 
		service.queryDataDict({"enum_type" : "zqzhlx"},function(data){
			console.log(JSON.stringify(data));
			if(data.error_no == 0 && data.results.length != 0)
			{
				var openAccountEnum = data.results;
				for(var i = 0;i<openAccountEnum.length;i++)
				{
					allOpenAccountStr += "<li><a href=\"javascript:void(0);\" class=\"icon_check\" id=\"selectAccount0"+i+
						"\" value=\""+openAccountEnum[i].item_value+"\">"+openAccountEnum[i].item_name+"</a></li>";
				}
				$(_pageId+" .radio_list ul").html(allOpenAccountStr);  // 填充 开通证券账户
				initSelect();  // 初始化证券账户的选择
			}
			else
			{
				layerUtils.iLoading(false);  // 关闭等待层。。。
				layerUtils.iAlert(data.error_info);
			}
		},false,true,handleTimeout);
	}
	
	/* 默认所有的账号都开通 */
	function initSelect()
	{
		// 删除深B、沪B
		$(_pageId+" .radio_list ul li a[value='2']").parent().remove();  
		$(_pageId+" .radio_list ul li a[value='4']").parent().remove();
		// 账号绑定提醒事件，数据填充完毕才绑定事件
		appUtils.bindEvent($(_pageId+" .radio_list ul li a"),function(e){
			confrimOpenAccount($(this));
			e.stopPropagation();
		});
		// 新开户默认开所有的股东账户
		if(appUtils.getSStorageInfo("openChannel") == "new")
		{
			$(_pageId+" .radio_list ul li a").addClass("checked");
			$(_pageId+" .radio_list ul li a[value='98']").removeClass("checked");
			$(_pageId+" .radio_list ul li a[value='99']").removeClass("checked");
		}
		// 转户需要查询原有的股东账户
		else if(appUtils.getSStorageInfo("openChannel") == "change")
		{
			if(!(appUtils.getSStorageInfo("finance") == "finance")){
				// 转户删除基金
				$(_pageId+" .radio_list ul li a[value='5']").parent().remove();  
				$(_pageId+" .radio_list ul li a[value='6']").parent().remove();
			}
			else{
				$(_pageId+" .radio_list ul li a[value='1']").parent().remove();  
				$(_pageId+" .radio_list ul li a[value='3']").parent().remove();
			}
			// 转户选中查询出来的证券账户
			var lookAccountParam = {"user_id" : appUtils.getSStorageInfo("user_id")};
			service.queryUserInfoExistCompy(lookAccountParam,function(data){
				var error_no = data.error_no;
				var error_info = data.error_info;
				// 调接口成功，选中开过的证券账户
			    if(error_no == 0 && data.result)
				{
					// stkbd 交易板块 0 深A；1 沪A；4 深基金；5  沪基金
					for(var i=0,len=data.results.length;i<len;i++)
					{
						switch(Number(data.results[i].stkbd))
						{
							case 0 :   // 深 A
								$(_pageId+" .radio_list ul li a[value='1']").addClass("checked");
								$(_pageId+" .radio_list ul li a[value='1']").attr("trdacct",data.results[i].trdacct);
								break;
	 						case 1 :   // 沪 A
								$(_pageId+" .radio_list ul li a[value='3']").addClass("checked");
								$(_pageId+" .radio_list ul li a[value='3']").attr("trdacct",data.results[i].trdacct);
								break;
						}
					}
				}
				else
				{
					layerUtils.iLoading(false);  // 关闭等待层。。。
 					$(_pageId+" .radio_list ul li a").addClass("checked");  //接口调用失败，则全选
				}
			},false,true,handleTimeout);
		}
	}
	
	/* 处理请求超时 */
	function handleTimeout()
	{
		layerUtils.iConfirm("请求超时，是否重新加载？",function(){
			getMarket();  // 再次获取市场代码和协议
		});
	}
	
	/* 提示用户若不开通某账号将影响正常交易 */
	function confrimOpenAccount(obj)
	{
		if($(obj).hasClass("checked"))
		{
			var accountName = $(obj).html();
			$(_pageId+" .btn_bot h5").html("确定取消开立\""+accountName+"\"账户？");
			$(_pageId+" .btn_bot p").html("不开通\""+accountName+"\"账户，将影响您该项正常交易<br>请您慎重选择");
			$(_pageId+" .btn_bot").show()
			// 确定取消
			appUtils.bindEvent($(_pageId+" .btn_box a:eq(0)"),function(e){
				$(obj).removeClass("checked");
				$(_pageId+" .btn_bot").hide();
				e.stopPropagation();
			});
			// 继续开立
			appUtils.bindEvent($(_pageId+" .btn_box a:eq(1)"),function(e){
				$(_pageId+" .btn_bot").hide();
				e.stopPropagation();
			});
		}
		else
		{
			$(obj).addClass("checked");  // 选中当前开通账户
		}
	}
	
	function bindPageEvent()
	{
		/* 隐藏按钮*/
		appUtils.bindEvent($(_pageId),function(e){
			$(_pageId+" .btn_bot").hide();
		});
		
		/* 绑定签署协议*/
		appUtils.bindEvent($(_pageId+" .rule_check .icon_check"),function(){
			$(this).toggleClass("checked"); //  切换勾选样式
		});
		
		/* 继续开户（下一步）*/
		appUtils.bindEvent($(_pageId+" .ct_btn a"),function(){
			getSignProtocl();  // 获取签名值并验签
		});
	}
	
	function destroy()
	{
		service.destroy();
	}
	
	function getAgreement(array){
		var jsonArray = new Array();
		var i = 0;
		if(array.length>0){
			var category_no = array[i];
			var queryListResult = function(data) {
				if (data.error_no == 0) {
					var results = data.results;
					if(results!=null && results.length>0){
						for(var j = 0;j<results.length;j++){
							jsonArray.push(results[j]);
						}
					}
					i += 1;
					if(i<array.length){
						category_no = array[i];
						service.queryProtocolList({"category_no":category_no},queryListResult,true,true);
					}else{
						showProtocolList(jsonArray);
					}
				}else{
					layerUtils.iLoading(false);  // 关闭等待层。。。
					layerUtils.iAlert(data.error_info);
				}
			};
			service.queryProtocolList({"category_no":category_no},queryListResult,true,true);
		}
	}
	
	function showProtocolList(jsonArray){
		fristMap = new Map();
		var allProtocols = "";
		var protocolMap = null;
		for(var i=0;i<jsonArray.length;i++){
			protocolMap = new Map();
			protocolMap.put("protocolid",jsonArray[i]["econtract_no"]);	//协议id
			protocolMap.put("protocolname",jsonArray[i]["econtract_name"]);	//协议名
			protocolMap.put("summary",jsonArray[i]["econtract_md5"]);	//协议内容MD5,签名摘要信息
			allProtocols += "<li><a href=\"javascript:void(0);\" protocol-id=\""+jsonArray[i]["econtract_no"]+"\" id=\"protocol0"+i+"\">《"+
			jsonArray[i]["econtract_name"]+"》</a></li>";
			// 预绑定查看协议的事件
			appUtils.preBindEvent($(_pageId+" .agreement_box ul"),"#protocol0"+i,function(e){
				appUtils.pageInit("account/signProtocol","account/showProtocol",{"protocol_id" : $(this).attr("protocol-id")});
				e.stopPropagation();
			});
			fristMap.put(i,protocolMap);
		}
		$(_pageId+" .agreement_box ul").html(allProtocols);
	}
	
	/* 处理请求超时 */
	function handleTimeout()
	{
		layerUtils.iConfirm("请求超时，是否重新加载？",function(){
			getAgreement();  // 再次获取协议
		});
	}
	
	/* 获取签名值 */
	function getSignProtocl()
	{
		var keys = fristMap.keys();  // 协议的数量
		// 检查是否勾选开通的账户
		if(!$(_pageId+" .radio_list a").hasClass("checked")){
			layerUtils.iMsg(-1,"请选择需开通的账户！");
			return false;
		}
		// 检查是否勾选签署协议
		if($(_pageId+" .rule_check a").hasClass("checked"))
		{
			layerUtils.iLoading(true);  // 开启等待层。。。
			var keys = fristMap.keys();  // 协议的数量
			var oneData = null;
			var protocolid = null;
			var protocolname = "";
			var summary = "";
			var protocol = "";
			for(var i=0;i<keys.length;i++){
				oneData = fristMap.get(keys[i]); // 取出一个协议
				protocolid = oneData.get("protocolid"); // 协议ID
				protocolname = oneData.get("protocolname");  //协议名称
				summary = oneData.get("summary");  // 协议内容MD5,签名摘要信息
				protocol = {
					"protocol_id" : protocolid,
					"summary" : summary
				};
				protocolArray.push(protocol);
			}
			startSign();  
		}
		else
		{
			layerUtils.iMsg(-1,"请阅读并勾选同意签署以上全部协议！");
			return false;
		}
	}
	
	/* 发请求进行协议验签 */
	function startSign()
	{
		var signProtocolParam = {
			"user_id" : userId,
			"jsondata" : JSON.stringify(protocolArray),
			"ipaddr" : appUtils.getSStorageInfo("ip"),
			"macaddr" : appUtils.getSStorageInfo("mac"),
			"checksign" : "0"
		};
		// 新开中登验签
		if(appUtils.getSStorageInfo("openChannel") == "new")
		{
			service.queryOpenCheckSign(signProtocolParam,callSign,false);
		}
		// 转户天威验签
		else if(appUtils.getSStorageInfo("openChannel") == "change")
		{
			service.queryOpenCheckTsign(signProtocolParam,callSign,false);
		}
	}
	
	/* 验签回调函数*/
	function callSign(data)
	{
		// 如果有一个协议签署失败，就将签署结果设为 false
	    if(data.error_no == 0)
		{
			openZjAccountAndClient();	//开立账户系统客户号和资金账户
		}
	    else
	    {
			layerUtils.iLoading(false);  // 关闭等待层。。。
			layerUtils.iAlert(data.error_info,-1);
	    }
	}
	
	/* 开立账户系统客户号和资金账户 */
	function openZjAccountAndClient()
	{
		//开立账户系统客户号和资金账户
		var param = {
			"user_id" : appUtils.getSStorageInfo("user_id")
		};
		service.queryOpenAccount(param,function(data){
			console.log(JSON.stringify(param));
			var error_no = data.error_no;
			var error_info = data.error_info;
			if(error_no == 0)	//调用成功
			{
				// 开立中登账户
				var openStockParam = {
					"user_id" : appUtils.getSStorageInfo("user_id"),
					"sza_str" : "",  // 深A开通情况，不开传空 ，新开 1 ，转户 2
					"sha_str" : "",  //沪A开通情况
					"szfnd_str" : "",  // 深基金开通情况
					"shfnd_str" : "",  // 沪基金开通情况
					"opfnd_str" : ""  // 通用开发试基金
				};
				// 深 A 的开通状况
				if($(_pageId+" .radio_list ul li a[value='1']").hasClass("checked"))
				{
					if(appUtils.getSStorageInfo("openChannel") == "new" || appUtils.getSStorageInfo("finance") == "finance"){
						openStockParam.sza_str = "1";
					}else{
						openStockParam.sza_str = "2";
					}
					if($(_pageId+" .radio_list ul li a[value='1']").attr("trdacct"))
					{
						openStockParam.sza_str += $(_pageId+" .radio_list ul li a[value='1']").attr("trdacct");
					}
				}
				// 沪 A 的开通状况
				if($(_pageId+" .radio_list ul li a[value='3']").hasClass("checked"))
				{
					if(appUtils.getSStorageInfo("openChannel") == "new" || appUtils.getSStorageInfo("finance") == "finance"){
						openStockParam.sha_str = "1";
					}else{
						openStockParam.sha_str = "2";
					}
					if($(_pageId+" .radio_list ul li a[value='3']").attr("trdacct"))
					{
						openStockParam.sha_str += $(_pageId+" .radio_list ul li a[value='3']").attr("trdacct");
					}
				}
				// 新开户才有基金，转户只有 A 股
				if(appUtils.getSStorageInfo("openChannel") == "new" || appUtils.getSStorageInfo("finance") == "finance")
				{
					// 深开放式基金的开通状况
					if($(_pageId+" .radio_list ul li a[value='98']").hasClass("checked"))
					{
						openStockParam.opfnd_str = "1|98"+",";
					}
					// 沪开放式基金的开通状况
					if($(_pageId+" .radio_list ul li a[value='99']").hasClass("checked"))
					{
						openStockParam.opfnd_str += "1|99";
					}
				}
				//开立中登股东账号
				service.queryOpenCompyAccount(openStockParam,function(data){
					if(data.error_no == 0)
					{
						// 标志驳回已被修改
						var notifyParam = {
							"user_id" : appUtils.getSStorageInfo("user_id"),
							"fieldname" : "account"  // 通知开股东卡已补全
						};
						service.rejectStep(notifyParam,function(data){
							console.log(JSON.stringify(notifyParam));
							console.log(JSON.stringify(data));
							if(data.error_no == 0)
							{
								//cleanPageElement();  // 清理页面元素
								appUtils.setSStorageInfo("isBack", "backInfo"); //标志重新提交资料成功
													var videoParam = appUtils.getSStorageInfo("videoParam");
													videoParam = JSON.parse(videoParam);
													if (videoParam.need_video == 1) {
														appUtils.pageInit("account/backSignProtocol", "account/videoNotice", {});
													} else {
														appUtils.pageInit("account/backSignProtocol", "account/accountResult", {});
													}
							}
							else 
							{
								layerUtils.iAlert(data.error_info,-1);
							}
						},false);
					}
					else
					{
						layerUtils.iLoading(false);
						layerUtils.iAlert(data.error_info,-1);
					}
				},false);
			}
			else
			{
				layerUtils.iLoading(false);
				layerUtils.iAlert(error_info,-1);
			}
		},false);
	}
	
	/* 清理界面元素 */
	function cleanPageElement()
	{
		$(_pageId+" .radio_list ul li").remove();  // 清理证券账户
		$(_pageId+" .agreement_box ul li").remove();  // 清理协议
	}
	
	var backSignProtocol = {
		"init" : init,
		"bindPageEvent" : bindPageEvent,
		"destroy" : destroy
	};
	
	module.exports = backSignProtocol;
});