/**
 * 三方存管
 */
define(function(require, exports, module){
    /* 私有业务模块的全局变量 begin */
    var appUtils       = require("appUtils"),
        global         = require("gconfig").global,
        platform       = require("gconfig").platform,
        service        = require("serviceImp").getInstance(),  // 业务层接口，请求数据
        layerUtils     = require("layerUtils"),
        utils          = require("utils"),
        endecryptUtils = require("endecryptUtils"),
        validatorUtil  = require("validatorUtil"),

        PROTOCOL       = null,  // 协议保存
        _pageId        = "#account_backThirdDepository";

    var CHANNEL_INFO,
        USER_ID,
        IP,
        MAC,
        REJECT_STEP,
        REJECT_INFO;

    /* 私有业务模块的全局变量 end */

    function init(){

        CHANNEL_INFO   = appUtils.getSStorageInfo("channelInfo");
        USER_ID        = appUtils.getSStorageInfo("user_id");
        IP             = appUtils.getSStorageInfo("ip");
        MAC            = appUtils.getSStorageInfo("mac");
        REJECT_STEP    = appUtils.getSStorageInfo("rejectStep");
        REJECT_INFO    = appUtils.getSStorageInfo("rejectInfo");


        var $reason       =  $(_pageId+' .reject-tips');
        showRejectReason($reason,['bankcode']);    //提示驳回原因
        $reason.fadeIn(500);
        $reason.on('click',function(){
            $(this).fadeOut();
        })

        getBankList();  /* 获取存管银行列表 */

    }


    function bindPageEvent(){
            
        var $agreement   = $(_pageId+" .agreement"),
            $bank_card   = $(_pageId+" #bankcard"),
            $bank_pwd    = $(_pageId+" #bankpwd"),
            $bank_brief  = $(_pageId+" #bankbrief"),
            $bank_select = $(_pageId+" #select-bank"),
            $bank_list   = $(_pageId+" .bank-list-demo"),
            $next        = $(_pageId+" .btn-next-step"),
            $argee_check = $(_pageId+" .agreement input");


        /* 银行卡号输入控制（每四位分隔） */
        appUtils.preBindEvent(_pageId,'#bankcard',function(){
            utils.dealIPhoneMaxLength(this,21); // 处理iphone兼容
            utils.showBigNo(this,2);            // 调用放大镜插件
        },"input");


        // 查看示例
        appUtils.bindEvent($bank_list,function(e){
            e.preventDefault();
            var demo_str = '<div class="overlay">'+
                                '<div class="info-window mt-40" >'+
                                    '<div class="pic-demo"><img src="images/bank_list.png" width="100%" height="auto" alt=""></div>'+
                                    '<div class="info-window-btn">我知道了</div>'+
                                '</div>'+
                            '</div>';
            $(_pageId).append(demo_str);
        });

        appUtils.preBindEvent(_pageId,'.info-window-btn',function(){
            $(_pageId+' .overlay').remove();
        });



        /**
         * 查看协议注意事项：
         *
         * 1.如果是填好银行卡号和密码之后查看的协议，
         *   则需要将卡号和密码暂时缓存，待从查看协
         *   议页面返回的时候，将表单默认填充
         * 2.未填充 则不管
         * 
         */
        appUtils.preBindEvent(_pageId+' .agreement label', 'a',function (e) {
            e.preventDefault()
            var protocolId = $(this).attr('data-id');

            //在查看协议的时候 如果用户已经选择了银行并输入了相应的卡号密码 则记录下来
            if($bank_select.val()){
                appUtils.setSStorageInfo("tmpBankcode",$bank_select.val().trim());
                appUtils.setSStorageInfo("tmpBankPwd",$bank_pwd.val().trim());
                appUtils.setSStorageInfo("tmpBankNum",$bank_card.val().trim());
            }

            appUtils.pageInit("account/thirdDepository", "account/showDigitalProtocol", {"protocolId": protocolId});
        });

        //切换银行
        appUtils.bindEvent($bank_select,function(){

            // 清空银行卡和密码
            $bank_card.val('');
            $bank_pwd.val('');

            checkNextBtnState();

            var bankcode = $bank_select.val();

            showElements();

            if(!bankcode){
                return;
            }

            getDepositoryAgreement(bankcode); //更新需要签署的协议

        },'change');

        //检测银行卡输入
        appUtils.bindEvent($bank_card,function(){
            checkNextBtnState();            
        },'input');

        //检测密码输入
        appUtils.bindEvent($bank_pwd,function(){
            checkNextBtnState();            
        },'input');

        //检测密码输入
        appUtils.bindEvent($argee_check,function(){
            checkNextBtnState();            
        },'change');

        /**
         * 下一步按钮
         *  1.检测按钮是否置灰
         *  2.验证表单
         *  3.提交信息
         * 
         */
        appUtils.bindEvent($next,function(){

            // 检测置灰状态
            if($(this).hasClass('disabled')){
                return;
            };

            //未能通过验证
            if(!validateInfo()){
                return;
            }

            signProtocol();  // 提交验签，并且提交三方存管信息
        });
    }


    function destroy(){
        service.destroy();
    }

    /* 获取存管银行列表 */
    function getBankList(){

        var $bank_select = $(_pageId+" #select-bank"),
            $bank_card   = $(_pageId+" #bankcard"),
            $bank_pwd    = $(_pageId+" #bankpwd");

        var queryParam   = {"bindtype" : "", "ispwd" : ""};

        service.queryBankList(queryParam,function(data){
            console.log(data);
            if(data.error_no==0) {

                var results = data.results;
                var channelInfo;

                var _prePageCode = appUtils.getSStorageInfo("_prePageCode");



                // 有渠道信息走渠道
                if(CHANNEL_INFO){ 
                    channelInfo = JSON.parse(CHANNEL_INFO);
                    if(channelInfo['bank_type']){
                        querylChannelBank(results,channelInfo['bank_type']);
                        return;
                    }
                }

                //如果是从协议页面返回
                if(_prePageCode=="account/showDigitalProtocol" || _prePageCode == "account/thirdDepository" ){


                    var tmp_bank_type = appUtils.getSStorageInfo("tmpBankcode"),
                        tmp_bank_num  = appUtils.getSStorageInfo("tmpBankNum"),
                        tmp_bank_pwd  = appUtils.getSStorageInfo("tmpBankPwd");

                    appUtils.clearSStorage('tmpBankcode');
                    appUtils.clearSStorage('tmpBankNum');
                    appUtils.clearSStorage('tmpBankPwd');

                    if(tmp_bank_type){
                        $bank_card.val(tmp_bank_num);
                        $bank_pwd.val(tmp_bank_pwd);
                        queryCommonBank(results,tmp_bank_type);
                        return;
                    }
                }

                // 走正常
                queryCommonBank(results);

            }else{
                layerUtils.iAlert(errorInfo,-1);
            }
        },true,true,handleTimeout);
    }

    /**
     * [querylChannelBank 渠道银行]
     * @param  data 结果集
     * @param  bank_type 银行代码
     * 
     */
    function querylChannelBank(results,bank_type){

        var $bank_select = $(_pageId+" #select-bank");

        for(var i = 0;i<results.length;i++){
            if(results[i]['bankcode'] == bank_type){

                var html_str = '<option value="'+results[i]['bankcode'] +
                                '" data-bankname="'+results[i]['bankname']+
                                '" data-zzispwd="'+results[i]['zzispwd']+
                                '" data-iscard="'+results[i]['iscard']+
                                '" data-zzbindtype="'+results[i]['zzbindtype']+
                                '" data-signinfo="'+results[i]['sign_info']+
                                '" data-brief="'+results[i]['brief']+
                                '" selected="selected'+
                                '">'+results[i]['bankname']+'</option>';

                $bank_select
                    .html(html_str)
                    .attr('disabled','disabled');
                getDepositoryAgreement(bank_type);
                showElements();
                return;
            }
        }
    }

    //银行列表
    function queryCommonBank(results,bank_type){
        var $bank_select = $(_pageId+" #select-bank");
        var html_str     ='<option value="">请选择银行</option>';

        bank_type = bank_type||'';
        for(var i = 0;i<results.length;i++){

            if(results[i]['bankcode'] == bank_type){

                html_str += '<option selected="selected" value="'+results[i]['bankcode'] +
                            '" data-bankname="'+results[i]['bankname']+
                            '" data-zzispwd="'+results[i]['zzispwd']+
                            '" data-iscard="'+results[i]['iscard']+
                            '" data-zzbindtype="'+results[i]['zzbindtype']+
                            '" data-signinfo="'+results[i]['sign_info']+
                            '" data-brief="'+results[i]['brief']+
                            '">'+results[i]['bankname']+'</option>';
                continue;
            }

            html_str+= '<option value="'+results[i]['bankcode'] +
                        '" data-bankname="'+results[i]['bankname']+
                        '" data-zzispwd="'+results[i]['zzispwd']+
                        '" data-iscard="'+results[i]['iscard']+
                        '" data-zzbindtype="'+results[i]['zzbindtype']+
                        '" data-signinfo="'+results[i]['sign_info']+
                        '" data-brief="'+results[i]['brief']+
                        '">'+results[i]['bankname']+'</option>';
        }

        $bank_select.html(html_str);
        showElements();
    }

    /**
     * [checkNextBtnState 切换下一步按钮状态]
     * 规则：
     * 1.未选择银行 则按钮灰掉
     * 2.选择了银行 银行卡号为空 灰掉按钮
     * 3.需要银行卡密码的 如果密码为空 灰掉按钮
     * 4.未能勾选协议 灰掉按钮
     */
    function checkNextBtnState(){
        var $bank_card     = $(_pageId+" #bankcard"),
            $bank_pwd      = $(_pageId+" #bankpwd"),
            $bank_select   = $(_pageId+" #select-bank"),
            $bank_selected = $(_pageId+" #select-bank option:selected"),
            $argee_check   = $(_pageId+" .agreement input"),
            $next          = $(_pageId+" .btn-next-step");

        //未选择银行
        if(!$bank_select.val()){
            $next.addClass('disabled');
            return;
        }

        //未输入银行卡号
        if(!$bank_card.val()){
            $next.addClass('disabled');
            return;
        }

        //需要输入密码，但密码为空
        if($bank_selected.attr('data-zzispwd') == 1 && !$bank_pwd.val()){
            $next.addClass('disabled');
            return;
        }

        //验证是否同意协议内容
        if(!$argee_check.is(':checked')){
            $next.addClass('disabled');
            return;
        };

        $next.removeClass('disabled');

    }


    // 处理请求超时 
    function handleTimeout(){
        layerUtils.iConfirm("请求超时，是否重新加载？",function(){
            getBankList();  // 再次获取银行列表
        });
    }

    // 检验银行卡填写是否正确 
    function validBankCard(){

        var bankcard = $(_pageId+" #bankcard").val();       //银行卡号
        //银行卡号为空
        if(!bankcard){
            layerUtils.iAlert("银行卡号不能为空！");
            return false;
        }

        // 银行卡格式有误
        if(!validatorUtil.isBankCode(bankcard)){
            layerUtils.iAlert("银行卡号格式有误，请重新输入！");
            return false;
        }

        return true;
    }




    // 验证银行密码 
    function validateBankPwd(){
        var cardPwd = $(_pageId+" #bankpwd").val();

        if(!cardPwd){
            layerUtils.iAlert("请输入银行卡密码！");
            return false;
        }

        if(!validatorUtil.isNumeric(cardPwd)){
            layerUtils.iAlert("银行卡密码格式错误，请输入6位数字密码！");
            return false;
        }

        if(cardPwd.length != 6){
            layerUtils.iAlert("银行卡密码错误，请输入6位数字密码！");
            return false;
        }

        return true;
    }

    /**
     * validateInfo 表单验证
     * 1.银行卡号：必须验证
     * 2.银行密码：按需求验证
     */
    function validateInfo(){

        var $bank_selected = $(_pageId+" #select-bank option:selected");

        // 银行卡号未能通过验证
        if(!validBankCard()){
            return false;
        }

        //需要输入密码 但是密码未能通过
        if($bank_selected.attr('data-zzispwd') == 1 && !validateBankPwd()){

            return false;
        }
        return true;
    }


    /**
     * [showElements 显示页面信息]
     * 根据选择的银行显示页面要展示的元素以及要提示的信息
     * 
     */
    function showElements(){
        var $bank_selected   = $(_pageId+" #select-bank option:selected"),
            $group_bank_card = $(_pageId+" #input-group-bankcard"),
            $group_bank_pwd  = $(_pageId+" #input-group-bankpwd"),
            $bank_brief      = $(_pageId+" #bankbrief"),
            $agreement       = $(_pageId+" .agreement");

        //根据是否选择了银行确定
        if($bank_selected.val()){
            $group_bank_card.show();
        }else{
            $group_bank_card.hide();
            $agreement.hide();
        }

        //根据是否需要银行卡密码确定是否显示输入密码选项
        if($bank_selected.attr('data-zzispwd') == 1){
            $group_bank_pwd.show();
        }else{
            $group_bank_pwd.hide();
        }

        //显示提示信息
        if($bank_selected.attr('data-brief')){
            $bank_brief.text($bank_selected.attr('data-brief').replace(/<[^>]+>/g,"")).show();
        }else{
            $bank_brief.hide();
        }
    }

    // 查询存管银行协议
    function getDepositoryAgreement(bankcode){

        var $agreement   = $(_pageId+" .agreement"),
            $label       = $agreement.find('label'),
            $protocol    = $label.find('#bank-protocol'),
            param        = {"econtract_no" : bankcode};

        service.queryProtocolList(param,function(data){
            if(data.error_no == 0 && data.results){
                PROTOCOL = data.results[0];
                $protocol.html('<a data-id="'+PROTOCOL.econtract_no+'" data-md5="'+PROTOCOL.econtract_md5+'" >《'+PROTOCOL.econtract_name+'》</a>');
                $agreement.show();
            }else{
                layerUtils.iAlert(data.error_info);
            }
        });
    }


    /**
     * [signProtocol 签署银行卡存管]
     * 
     * 1.新开中登验签
     * 2.提交三方存管数据
     */
    function signProtocol(){

        var protocolArray = [];

        protocolArray.push({
            "protocol_id" : PROTOCOL.econtract_no,  // 协议编号
            "summary"     : PROTOCOL.econtract_md5  // 协议内容MD5,签名摘要信息
        });   

        var param = {
            "user_id"   : USER_ID,
            "jsondata"  : JSON.stringify(protocolArray),
            "ipaddr"    : IP,
            "macaddr"   : MAC,
            "checksign" : "0"
        };

        service.queryOpenCheckSign(param,function(data){

            if(data.error_no == 0){
                postThirdDepositoryData();
            }else{
                layerUtils.iLoading(false);
                layerUtils.iAlert(data.error_info);
            }
        },false);
    }

    /**
     * [postThirdDepositoryData 提交三方存管信息]
     */
    function postThirdDepositoryData() {

        var $bank_pwd    = $(_pageId + " #bankpwd"),
            $bank_select = $(_pageId + " #select-bank"),
            $bank_card   = $(_pageId + " #bankcard"),
            bankcode     = $bank_select.val(),
            bankaccount  = $bank_card.val(),
            bank_pwd     = $bank_pwd.val().trim(),
            zzbindtype   = $bank_select.attr("data-zzbindtype");

        //获取rsa公钥
        service.getRSAKey({}, function(data) {
            if (data.error_no == 0) { 

                //密码采用rsa加密
                var results        = data.results[0],
                    modulus        = results.modulus,
                    publicExponent = results.publicExponent,
                    bankpwd        = endecryptUtils.rsaEncrypt(modulus, publicExponent,bank_pwd);

                var param = {
                    "user_id"      : USER_ID,
                    "acct_clientid": "",
                    "acct_fndacct" : "",
                    "bank_code"    : bankcode,
                    "bank_account" : bankaccount,
                    "bank_pwd"     : bankpwd,
                    "op_type"      : zzbindtype
                };

                // 调用service绑定存管银行
                service.bindBank(param, function(data) {

                    if(data.error_no == 0){// 调用成功,跳转到风险测评页面
                        cleanPageElement();
                            //调用提交补全资料接口
                            var param = {
                                "user_id" : USER_ID,
                                "fieldname" : "bind_bank",  // 绑定三方存管
                                "laststep_is_witness":"1"
                            };

                            service.rejectStep(param,function(data){
                                if(data.error_no == 0){

                                    REJECT_STEP = JSON.parse(REJECT_STEP);
                                    delete REJECT_STEP['backThirdDepository'];
                                    appUtils.setSStorageInfo('rejectStep',JSON.stringify(REJECT_STEP));

                                    // 驳回视频录制
                                    if (REJECT_STEP['backPostConfirm']) {
                                        appUtils.pageInit("account/backThirdDepository", "account/backPostConfirm");
                                        return;
                                    }
                                    //完成
                                    appUtils.pageInit("account/backThirdDepository", "account/success");

                                }
                            });
                            
                    } else {
                        layerUtils.iLoading(false);
                        layerUtils.iAlert(data.error_info);
                    }
                }, false);

            } else {
                layerUtils.iLoading(false);
                layerUtils.iAlert(data.error_info);
            }
        }, false);
    }

    /**
     * [showRejectReason 提示驳回原因]
     * @param  {[type]} $dom 需要填充的位置
     * @param  {[type]} arr  本步骤涉及到的驳回字段
     * 
     */
    function showRejectReason($dom,arr){

        var resons        =  JSON.parse(REJECT_INFO),
            currentReason = [],
            html_str      ="";

        //遍历出当前步骤驳回的原因
        for(var i = 0;i<resons.length;i++){
            if(arr.indexOf(resons[i]['fieldenname'])>-1){
                currentReason.push(resons[i]);
            }
        }

        //拼接提示字符串
        for(var j = 0;j<currentReason.length;j++){
            html_str+='<p><strong>'+currentReason[j]['fielddesc']+'</strong> '+currentReason[j]['rejreason']+'</p>';
        }

        html_str=html_str||'<p><strong>您的三方存管绑定失败，请重新绑定</strong></p>';

        $dom.html(html_str);
    }


    // 清理界面元素 
    function cleanPageElement(){
        $(_pageId+" #bankcard").val("");  // 清理银行卡号
        $(_pageId+" #bankpwd").val("");  // 清理密码
    }

    // 暴露对外的接口
    module.exports = {
        "init" : init,
        "bindPageEvent" : bindPageEvent,
        "destroy" : destroy
    };

});