/**
 * 三方存管
 */
define(function(require, exports, module){ 
	/* 私有业务模块的全局变量 begin */
	var appUtils = require("appUtils"),
		global = require("gconfig").global,
		platform = require("gconfig").platform,
		service = require("serviceImp").getInstance(),  // 业务层接口，请求数据
		layerUtils = require("layerUtils"),
		utils = require("utils"),
		validatorUtil = require("validatorUtil"),
		zzispwd = 1,  // zzispwd	密码方式，1 需要，0 不需要
		iscard = 1,  // iscard	是否需要银行卡，1 需要，0 不需要
		_pageId = "#account_bankList";
	/* 私有业务模块的全局变量 end */
	
	function init()
	{
		getBankList(); //加载银行列表
	}
	
	function bindPageEvent(){
		// 绑定返回
		appUtils.bindEvent($(_pageId+" .header .icon_back"),function(){
			appUtils.pageBack();
		});
	}
	
	function destroy()
	{
//		$(_pageId+" input").val("");  // 把所有的input置空
		service.destroy();
	}
	
	/* 获取存管银行列表 */
	function getBankList()
	{
		var queryParam = {"bindtype" : "", "ispwd" : ""};
		service.queryBankList(queryParam,function(data){
			console.log(JSON.stringify(data));
			var errorNo = data.error_no;
			var errorInfo = data.error_info;
			$(_pageId+" .sel_list ul").html("");  // 清除页面的银行列表
			if(errorNo==0 && data.results.length != 0)
			{
				var results = data.results;
				var length = results.length;
				var itemElement = "";
				var otherItemElement = "";
				for(var i =0; i<length; i++)
				{
					var item = results[i],
				   		  bankcode = item.bankcode,  // 银行代码
						  bankname = item.bankname,  // 银行名称
						  zzbindtype = item.zzbindtype, // 绑定方式：1 一步式 2 预指定 3 同时支持两种方式
					      sortnum  = item.sortnum,  // 排序
					      smallimg = item.smallimg, // 图标
					      isbuffet = item.isbuffet, // 是否支持自助
					      sign_info = item.sign_info, // 提示信息简介
					      brief = item.brief; // 银行简介
				    zzispwd = item.zzispwd; // 密码方式：1 需要 0 不需要  
				    iscard = item.iscard; // 卡号方式：1 需要 0 不需要  smallimg
//				    if(i<4){
				    itemElement += "<li bankname='"+bankname+"' id='"+bankcode+"' " +"zzispwd=\""+zzispwd+"\""+
									            "iscard=\""+iscard+"\"  zzbindtype=\""+zzbindtype+"\" sign-info=\""+sign_info+"\" brief=\""+brief+"\"><img src='"+global.imgServerUrl+smallimg+"'></li>";
//				    }
//				    else{
//				    	otherItemElement += "<li bankname='"+bankname+"' id='"+bankcode+"' " +"zzispwd=\""+zzispwd+"\""+
//									            "iscard=\""+iscard+"\"  zzbindtype=\""+zzbindtype+"\" sign-info=\""+sign_info+"\"><img src='"+global.imgServerUrl+smallimg+"'></li>";
//				    }
				}
				$(_pageId+" .main ul:eq(0)").html(itemElement);
//				$(_pageId+" .main ul:eq(1)").html(otherItemElement);
				if((appUtils.getSStorageInfo("_prePageCode") == "account/showProtocol") || (appUtils.getSStorageInfo("_prePageCode") == "account/thirdDepository")){
					var bankNum = appUtils.getSStorageInfo("bankNum");
					var bankPwd = appUtils.getSStorageInfo("bankPwd",true);
					iscard = $(_pageId+" #selectBank").attr("iscard");
					$(_pageId+" #bankcard").val(bankNum);
					$(_pageId+" #bankcardPwd").val(bankPwd);
				}
				// 选择银行添加银行事件
				appUtils.bindEvent($(_pageId+" .bank_selebox ul li"),function(e){
//					$(_pageId+" #bankListPage ul li").removeClass("active");
//					$(this).parent().addClass("active");
//					$(_pageId+" .protocolshow").show();
					var banckName = $(this).attr("bankname"),
						id = $(this).attr("id"),
						zzbindtype = $(this).attr("zzbindtype"),  // 绑定方式
						signInfo = $(this).attr("sign-info");  // 提示信息
				   		zzispwd = $(this).attr("zzispwd");  // 密码方式
				    	iscard = $(this).attr("iscard");  // 是否需要银行卡号
				    	brief = $(this).attr("brief");  // 银行简介
					addBankItem(banckName,id,zzbindtype,signInfo,iscard,zzispwd,brief);
					e.stopPropagation();
				});
			}
			else
			{
				layerUtils.iAlert(errorInfo,-1);
			}
		},true,true,handleTimeout);	
	}
	
	/* 处理请求超时 */
	function handleTimeout()
	{
		layerUtils.iConfirm("请求超时，是否重新加载？",function(){
			getBankList();  // 再次获取银行列表
		});
	}
	
	/* 为选择银行列表添加选中银行数据 */
	function addBankItem(banckName,id,zzbindtype,signInfo,iscard,zzispwd,brief)
	{
		//从三方存管页面进入
		if(appUtils.getSStorageInfo("_prePageCode") == "account/thirdDepository")
		{
			appUtils.pageInit("account/bankList","account/thirdDepository",{"banckName":banckName,"id":id,
			"zzbindtype":zzbindtype,"signInfo":signInfo,"iscard":iscard,"zzispwd":zzispwd,"brief":brief});
		}
		//从驳回三方存管页面进入
		else if(appUtils.getSStorageInfo("_prePageCode") == "account/backThirdDepository")
		{
			appUtils.pageInit("account/bankList","account/backThirdDepository",{"banckName":banckName,"id":id,
			"zzbindtype":zzbindtype,"signInfo":signInfo,"iscard":iscard,"zzispwd":zzispwd,"brief":brief});
		}
	}
	
	/* 签署协议 */
	function signProtocol()
	{
		if(!validateSelectBank())  // 验证是否选择银行
		{
			return false;
		}
		if((iscard == 1 || iscard == "") && !validateBankCorrect())  // 验证银行卡号
		{
			return false;
		}
		if(zzispwd == 1)  // 验证是否需要密码
		{
			if(!validateBankPwd())
			{
				return false;
			}
		}
//		if(!validateDepositProtocolSelect())  // 验证是否勾选协议
//		{
//			return false;
//		}
		// 进行协议签署
		var protocolArray = new Array(),  // 协议数组
			userid = appUtils.getSStorageInfo("user_id"),
			ipaddr  = appUtils.getSStorageInfo("ip"),
			macaddr = appUtils.getSStorageInfo("mac"),
			protocolid = protocol.econtract_no,
			protocolname = protocol.econtract_name,
			summary = protocol.econtract_md5,  // 协议内容MD5,签名摘要信息
			signParam = {
				"medid":protocolid,
				"content":summary,
				"userId":userid,
				"type": cert_type
			};
		layerUtils.iLoading(true);  // 开启等待层......
		// 获取协议的数字签名值
		require("shellPlugin").callShellMethod("signPlugin",function(data){
			var protocoldcsign = data.ciphertext;  // 数字签名值
			var protocolParam = {
				"protocol_id" : protocolid,
				"protocol_dcsign" : protocoldcsign,
				"summary" : summary
			};
			protocolArray.push(protocolParam);   // 添加值到数组中
			// 签署协议
			var signProtocolParam = {
				"user_id" : userid,
				"jsondata" : JSON.stringify(protocolArray),
				"ipaddr" : ipaddr,
				"macaddr" : macaddr
			};
			// 新开中登验签
			if(appUtils.getSStorageInfo("openChannel") == "new")
			{
				service.queryOpenCheckSign(signProtocolParam,postThirdDepositoryData,false);
			}
			// 转户天威验签
			else if(appUtils.getSStorageInfo("openChannel") == "change")
			{
				service.queryOpenCheckTsign(signProtocolParam,postThirdDepositoryData,false);
			}
		},function(){ layerUtils.iLoading(false); },signParam);
	}
	
	/* 提交三方存管银行数据 */
	function postThirdDepositoryData(data)
	{	
		if(data.error_no == 0){
			service.getRSAKey({}, function(data) {
				if( data.error_no==0)	//请求获取rsa公钥成功
				{
					//密码采用rsa加密
					var results = data.results[0];
					var modulus = results.modulus;
					var publicExponent =  results.publicExponent;
					var endecryptUtils = require("endecryptUtils");
					
					var bankpwd = endecryptUtils.rsaEncrypt(modulus, publicExponent, $(_pageId+" #bankcardPwd").val().trim());
					var userid = appUtils.getSStorageInfo("user_id");
					var bankcode= $(_pageId+" #selectBank").attr("bankcode");
					var bankaccount = $(_pageId+" #bankcard").val();
					var thirdDepositParam = {
						"user_id":userid,
						"acct_clientid":"",
						"acct_fndacct":"",
						"bank_code":bankcode,
						"bank_account":bankaccount,
						"bank_pwd":bankpwd,
						"op_type":$(_pageId+" #selectBank").attr("zzbindtype")
					};
					// 调用service绑定存管银行
					service.bindBank(thirdDepositParam,function(data){
						var errorNo = data.error_no;
						var errorInfo = data.error_info;
						if(errorNo==0)	 // 调用成功,跳转到风险测评页面
						{
							cleanPageElement();
							appUtils.pageInit("account/thirdDepository","account/riskAssessment",{});
						}
						else
						{
							layerUtils.iLoading(false);
							layerUtils.iAlert(errorInfo,-1);
						}
					},false);
				}
				else
				{
					layerUtils.iLoading(false);
					layerUtils.iAlert(data.error_info);
				}
			}, false);
		}else{
			layerUtils.iAlert(data.error_info,-1);
		}
	}
	
	/* 验证是否选择银行  */
	function validateSelectBank()
	{
		var obj = $(_pageId+" #selectBank");
		var value = obj.html();
		if(validatorUtil.isEmpty(value)||value=="请选择银行")
		{
			layerUtils.iMsg(-1,"请选择银行");
			return false;
		}
		return true;
	}
	
	/* 检验银行卡填写是否正确 */
	function validateBankCorrect()
	{
		var bankcard = $(_pageId+" #bankcard").val();
		if(bankcard == "")  // 验证通过的情况
		{
			layerUtils.iMsg(-1,"银行卡号不能为空！");
			return false;
		}
		if(!validatorUtil.isBankCode(bankcard))
		{
			layerUtils.iMsg(-1,"银行卡号格式有误，请重新输入！");
			return false;
		}
		return true;
	}
	
	/* 验证银行密码 */
	function validateBankPwd()
	{
		var cardPwd = $(_pageId+" #bankcardPwd").val();
		if(!validatorUtil.isNumeric(cardPwd) || cardPwd.length !=6)
		{
			layerUtils.iMsg(-1,"银行卡密码有误，请重新输入！");
			return false;
		}
		return true;
	}
	
	/* 检测勾选阅读协议 */
	function validateDepositProtocolSelect()
	{
		if(!$(_pageId+" .icon_check").hasClass("checked"))
		{
			layerUtils.iMsg(-1,"请阅读并勾选三方存管协议!");
			return false;
		}
		return true;
	}
	
	/* 获取存管银行签约电子协议列表 */
	function getDepositoryAgreement(bankcode)
	{
		$(_pageId+" #protocolName").html("");  // 清空协议
		// 调用service查询存管银行协议
		var param = {"econtract_no" : bankcode};
		service.queryProtocolList(param,function(data){
			$(_pageId+" #protocolName").html("");
			if(data.error_no == 0)
			{
				if(data.results&&data.results.length>=1)
				{
					protocol = data.results[0];
					$(_pageId+" #protocolName").html("《"+protocol.econtract_name+"》");
					$(_pageId+" #protocolName").attr("protocolId",protocol.econtract_no);
					$(_pageId+" #protocolName").attr("protocolMd5",protocol.econtract_md5);
					// 预绑定查看银行协议内容的事件
					appUtils.preBindEvent($(_pageId+" #protocolName").parent(),"#protocolName",function(){
						appUtils.setSStorageInfo("bankPwd",$(_pageId+" #bankcardPwd").val().trim(),true);
						appUtils.setSStorageInfo("bankNum",$(_pageId+" #bankcard").val());
						appUtils.pageInit("account/backThirdDepository","account/showProtocol",{"protocol_id":$(_pageId+" #protocolName").attr("protocolId")});
					});
				}
			}
			else
			{
				layerUtils.iAlert(data.error_info,-1);
			}
		});
	}
	
	/* 清理界面元素 */
	function cleanPageElement()
	{
		$(_pageId+" .rule_check a").removeClass("checked");  // 取消勾选协议
		$(_pageId+" #selectBank").text("请选择银行");  // 清理银行卡的名字
		$(_pageId+" #bankcard").val("");  // 清理银行卡号
		$(_pageId+" #bankcardPwd").val("");  // 清理密码
		$(_pageId+" #protocolName").text("《券商银行投资者三方协议》");  // 清理协议名
		$(_pageId+" #signInfo").html("");  // 清除银行签约信息
	}
	
	var bankList = {
		"init" : init,
		"bindPageEvent" : bindPageEvent,
		"destroy" : destroy
	};
	
	// 暴露对外的接口
	module.exports = bankList;
});