/**
* 开户确认（问卷回访）
*/
define(function(require,exports,module){

	var appUtils      = require("appUtils"),
		service       = require("serviceImp").getInstance(), //业务层接口，请求数据
		global        = require("gconfig").global,
		layerUtils    = require("layerUtils"),
		_pageId       = "#account_openConfirm";

	var	QUESTION_AMOUNT = 0,
		CUSTNAME,
		USER_ID;


	function init(){

		CUSTNAME      = appUtils.getSStorageInfo('custname');
		USER_ID       = appUtils.getSStorageInfo("user_id");

		getOpenConfirmData(); //获取问卷回访问题
	}

	function bindPageEvent(){
		var $next = $(_pageId+' .btn-next-step');

		appUtils.bindEvent($next,function(){

			var ans = verifyAnswer();

			if(ans){
				submitAnswer(ans);
			}
		});
	}

	function destroy(){
		$(_pageId).remove();
		service.destroy();
	}

	/* 获取开户确认回访问卷 */
	function getOpenConfirmData(){

		var $question_list = $(_pageId+' .question-list');

		var param = {
			"user_id":USER_ID,
			"sub_id":"5000"
		};

		$question_list.html('');
		// 获取回访问卷题目
		service.getVisitSub(param,function(data){
			console.log(data);
			if(data.error_no==0 && data.results){
				var results  = data.results,
					arr      = [],
					html_str = '';
				//按照题目id将数据排序
				results.sort(function(obj1,obj2){
					return obj1.que_id - obj2.que_id;
				});
				//将同一道题目的答题选项分成同一个组
				if(results.length == 1){
					arr.push({
						que_id :results[0]['que_id'],
						q_name :results[0]['q_name'],
						type:results[n]['type'],
						ans:results
					})
				}else{
					for(var i = 0,n = 0; i+1 < results.length; i++){

						if(results[i]['que_id'] != results[i + 1]['que_id']){

							arr.push({
								que_id :results[n]['que_id'],
								q_name :results[n]['q_name'],
								type:results[n]['type'],
								ans: results.slice(n,i+1)
							});

							n =i+1;

						}else if(i+2 == results.length){

							arr.push({
								que_id :results[n]['que_id'],
								q_name :results[n]['q_name'],
								type:results[n]['type'],
								ans: results.slice(n,i+2)
							});
						}
					}
				}

				QUESTION_AMOUNT = arr.length;  //获取题目数量

				for(var p = 0; p < arr.length ; p++){

					html_str+='<div class="que-item">'+
								'<div class="ask">'+(p+1)+'. '+(p == 0 ? CUSTNAME+arr[p]['q_name'].slice(3) : arr[p]['q_name'])+'</div>'+
								'<div class="ans">';

					for(var q = 0;q<arr[p]['ans'].length;q++){
						html_str+='<label><input type="radio" name="q'+p+'"'+(arr[p]['ans'][q]['mark'] == 1 ?' checked="checked"' : '')+' value="'+arr[p]['que_id']+'_'+arr[p]['ans'][q]['ans_id']+'_'+arr[p]['ans'][q]['mark']+'" data-mark="'+arr[p]['ans'][q]['mark']+'" class="pull-left"><span>'+arr[p]['ans'][q]['a_name']+'</span></label>'
					}

					html_str+='</div></div>';
				}

				$question_list.html(html_str);
			}
		},true,true,handleTimeout);
	}

	/* 处理请求超时 */
	function handleTimeout(){
		layerUtils.iConfirm("请求超时，是否重新加载？",function(){
			getOpenConfirmData();  // 再次获取问卷回访题目
		});
	}

	/**
	 * [verifyAnswer 检验问题答案]
	 * 1.如果验证失败 提示失败并返回 false
	 * 2.如果通过验证 则返回答案字符串
	 */
	function verifyAnswer(){
		var answered   = '',
			unanswered = '',
			v='',
			m='',
			$item;

		for(var i = 0; i < QUESTION_AMOUNT;i++){
			$item = $(_pageId+' input[name=q'+i+']:checked');
			v = $item.val();
			m = $item.attr('data-mark');
			if(m==1){
				answered+= v+'|';
			}else{
				unanswered+=(i+1)+'、';
			}
		}

		if(unanswered){
			unanswered = unanswered.substring(0,unanswered.length-1);	//去掉最后一个'、'
			layerUtils.iAlert("您的答题尚未答对，未答对题目编号：["+unanswered+"]");
			return false;
		}

		return answered;

	}

	/**
	 * [submitAnswer 提交答案]
	 * @param  {string} keys 答案字符串  {que_id}_{ans_id}_{mark}|{que_id}_{ans_id}_{mark}|
	 */
	function submitAnswer(keys){
		var param = {
			"user_id" : USER_ID,
			"q_a_args": keys,
			"sub_id"  :"5000"
		};

		service.submitVisitAnswer(param,function(data){
			if(data.error_no==0){ // 调用成功,跳转到风险测评页面
				appUtils.pageInit("account/openConfirm","account/postConfirm");  //姿势识别
			}else{
				layerUtils.iAlert(data.error_info);
			}
		});

	}



	var questionnaireReturn = {
		"init" : init,
		"bindPageEvent" : bindPageEvent,
		"destroy" : destroy
	};

	module.exports = questionnaireReturn;
});
