/**
 * 填写个人信息
 */

define(function(require, exports, module){
	/* 私有业务模块的全局变量 begin */
	var appUtils      = require("appUtils"),
		service       = require("serviceImp").getInstance(),  //业务层接口，请求数据
		global        = require("gconfig").global,
		layerUtils    = require("layerUtils"),
		// utils         = require("utils"),
		sexID         = {},                                   //性别ID
		validatorUtil = require("validatorUtil"),
		idCardModify  = false,                                // 身份证是否被手工修改
		_pageId       = "#account_personInfo";

	var INFO_PARAM,
		USER_ID,
		BRANCH_NO,
		COMMISSION,
		IP,
		MAC,
		MOBILE_NO,
		BROKER_INFO,
		RECOMMAND_NO,
		AGENT;

	/* 私有业务模块的全局变量 end */

	function init(){

		INFO_PARAM = appUtils.getPageParam("infoParam")||JSON.parse(appUtils.getSStorageInfo("infoParam"));

		USER_ID         = appUtils.getSStorageInfo("user_id");
		BRANCH_NO       = appUtils.getSStorageInfo("branchno");
		COMMISSION      = appUtils.getSStorageInfo("commission");
		IP              = appUtils.getSStorageInfo("ip");
		MAC             = appUtils.getSStorageInfo("mac");
		MOBILE_NO       = appUtils.getSStorageInfo("mobileNo");
		RECOMMAND_NO    = appUtils.getSStorageInfo("recommand_no");  //普通推荐码
		AGENT           = appUtils.getSStorageInfo("agent");         //经纪人编码
		BROKER_INFO     = JSON.parse(appUtils.getSStorageInfo("broker_info"));

		var $id_name        = $(_pageId+" .id-name"),
			$id_no          = $(_pageId+" .id-no"),
			$id_addr        = $(_pageId+" .id-addr"),
			$id_postcode    = $(_pageId+" .id-postcode"),
			$id_degree      = $(_pageId+" .id-degree"),
			$id_occup       = $(_pageId+" .id-occup"),
			$id_recommendno = $(_pageId+" .id-recommendno"),
			$id_begindate = $(_pageId+" .id-begindate"),
			$id_enddate   = $(_pageId+" .id-enddate");

		$id_name.val(INFO_PARAM.custname);
		$id_no.val(INFO_PARAM.idno);
		$id_addr.val(INFO_PARAM.native||INFO_PARAM.addr);
		$id_postcode.val(INFO_PARAM.postid);
		$id_begindate.val(INFO_PARAM.idbegindate);
		$id_enddate.val(INFO_PARAM.idenddate);

		if(BROKER_INFO){ //经纪人推荐码推荐码
			$id_recommendno.val(AGENT).attr('readonly','readonly');
		}else if(RECOMMAND_NO){  // 普通推荐码
			$id_recommendno.val(RECOMMAND_NO).attr('readonly','readonly');
		}

		initOccupation($id_occup); //初始化职业选项
		initDegree($id_degree);    //初始化学历选择
		// querySex();                //查询性别ID
	}


	function bindPageEvent(){

		var $id_name      = $(_pageId+" .id-name"),
			$id_no        = $(_pageId+" .id-no"),
			$id_addr      = $(_pageId+" .id-addr"),
			$id_postcode  = $(_pageId+" .id-postcode"),
			$id_begindate = $(_pageId+" .id-begindate"),
			$id_enddate   = $(_pageId+" .id-enddate"),
			$id_degree    = $(_pageId+" .id-degree"),
			$id_occup     = $(_pageId+" .id-occup"),
			$next         = $(_pageId+" .btn-next-step");

		//处理iphone兼容  15个汉字
		// appUtils.bindEvent($id_name,function(){
		// 	utils.dealIPhoneMaxLength(this,16);
		// },"input");

		//处理iphone兼容 18位数字
		appUtils.bindEvent($id_no,function(){
			// utils.dealIPhoneMaxLength(this,18);

			if($id_no.val()!== INFO_PARAM['idno']){ //身份证被手工修改过
				idCardModify = true;
			}else{
				idCardModify = false;
			}

		},"input");


		/**
		 * [下一步]
		 * 本地验证信息 --> 公安校验身份证用户名  --> 提交信息  -->跳转下一步
		 * verifyInfo-->identityRecognition->submitInfo->
		 */
		appUtils.bindEvent($next,function(){
			if(verifyInfo()){           // 校验数据
				identityRecognition();  //公安校验
			}
		});
	}

	/* 处理返回按钮 */
	function pageBack(){
		var currentStep = appUtils.getSStorageInfo("currentStep");
		// 当前完成步骤为：已成功上传身份证 或者 由视频返回到资料提交页，处理返回按钮
		if(appUtils.getSStorageInfo("personInfo") == "exist" || currentStep == "uploadimg")
		{
			appUtils.setSStorageInfo("currentStep","uploadimg");
			appUtils.setSStorageInfo("idInfo","exist");  // 标记用户完成照片上传
			appUtils.pageInit("account/personInfo","account/uploadPhoto");
		}
		// 正常开户处理返回按钮
		else
		{
			appUtils.pageBack();
		}
	}


	function destroy(){
		service.destroy();
	}

	/*提交开户信息*/
	function submitInfo(){
		var param = getSubmitDataParam();
		service.submitUserInfo(param,function(data){
			layerUtils.iLoading(false);
			if(data.error_no == 0){
				appUtils.setSStorageInfo("idCardNo",$(_pageId+" .id-no").val());
				appUtils.setSStorageInfo("custname",$(_pageId+" .id-name").val());

				syncCustInfo();

			}else{// 填写资料失败，弹出提示
				layerUtils.iAlert(data.error_info);
			}
		},false);
	}



	/**
	 * querySex 查询性别代码
	 * 根据查询结果设置全局变量男女的性别代码
	 *
	 */
	function querySex() {
	    var param = {
	        "enum_type": "sex"
	    };

	    service.queryDataDict(param, function(data) {
	    	console.log(data);
	        if (data.error_no == "0" && data.results.length != 0) {
	            var sex = data.results;
	            for (var i = 0; i < sex.length; i++) {

	                if (sex[i].item_name == "男") {
	                    sexID.male = sex[i].item_value;
	                }else if (sex[i].item_name == "女") {
	                    sexID.famale = sex[i].item_value;
	                }else if(sex[i].item_name == "其他") {
	                    sexID.others = sex[i].item_value;
	                }
	            }
	        } else {
	            layerUtils.iAlert(data.error_info); // 提示错误信息
	        }
	    }, true, true, handleTimeout);
	}

	/**
	 * [getSexID description]
	 * @param  {[type]} idno 身份证号
	 * @return {[type]}      返回性别信息  男 0 女 1
	 */
	function getSexID(idno){
		idno = idno.toString();
		return idno.charAt(idno.length-2) % 2 == 0 ? 1 : 0;
	}




	/* 获取用户信息*/
	function getSubmitDataParam(){

		var param                = {};

		param.idno               = $(_pageId+" .id-no").val();                             // 身份证号
		param.custname           = $(_pageId+" .id-name").val();                           // 用户名
		param.recommendno        = $(_pageId+" .id-recommendno").val();                    // 推荐人
		param.postid             = $(_pageId+" .id-postcode").val();                       // 邮政编码
		param.edu                = $(_pageId+" .id-degree").val();                         // 学历代码
		param.profession_code    = $(_pageId+" .id-occup").val();                          // 职业代码
		param.addr               = $(_pageId+" .id-addr").val().replace(/\s+/g,""),        // 联系地址

		param.native             = INFO_PARAM["addr"];                                      // 证件地址
		param.ethnicname         = INFO_PARAM["ethnicname"];                                // 民族
		param.birthday           = param.idno.slice(6,10)+'-'+param.idno.slice(10,12)+'-'+param.idno.slice(12,14);  // 出生日期
		param.idbegindate        = $(_pageId+" .id-begindate").val();                     // 证件开始日期
		param.idenddate          = $(_pageId+" .id-enddate").val();                       // 证件结束日期
		param.policeorg          = INFO_PARAM["policeorg"];                                 // 签发机关


		param.idtype             = '00';                                                   // 证件类别，数据字典中定义的是 00
		param.nationality        = "156";                                                  // 屏蔽，待解决  // 国籍地区，必须写 156
		param.provinceno         = "";                                                     // 省份代码,
		param.cityno             = "";                                                     // 城市代码

		param.infocolect_channel = iBrowser.pc ? 0 : 3;                                    // 信息来源渠道 0：PC  3：手机
		param.user_id            = USER_ID;                                                // 用户id
		param.usersex            = getSexID(param.idno);                                   // 用户性别，男 0 女 1 其他 2
		param.branchno           = BRANCH_NO;                                               // 营业部代码
		param.commission         = COMMISSION;                                             // 营业部代码佣金代码
		param.ipaddr             = IP;                                                     // ip 地址，在获取 短信验证码 的时候，就已经把 ip 和 mac 保存到 session 里面了
		param.macaddr            = MAC;                                                    // mac 地址
		param.idcardmodify       = idCardModify ? 1 : 0;                                   // 身份证是否被手动修改，被修改传 1 ，否则传 0

		return param;
	}


	/**
	 * initOccupation 初始化职业选项
	 * @param  {jQuery} $selector  jQuery选择器
	 * @param  {string} default_occu  已经存在的默认值
	 *
	 */
	function initOccupation($selector,default_occu){

		var param = {"enum_type" : "occupational"};
		service.queryDataDict(param,function(data){
			layerUtils.iLoading(false);
			console.log(data);

			if(data.error_no == "0" && data.results){

				var select_str = '',
					occup      = data.results;

				if(typeof default_occu == 'undefined'|| default_occu===''){
					select_str += '<option value="">请选择职业</option>';
				}

				for(var i= 0;i < occup.length;i++){
					if(default_occu && default_occu == occup[i]['item_value']){
						select_str+='<option selected="selected" value="'+occup[i]['item_value']+'">'+occup[i]['item_name']+'</option>';
					}else{
						select_str+='<option value="'+occup[i]['item_value']+'">'+occup[i]['item_name']+'</option>';
					}
				}
				$selector.html(select_str);
			}else{
				layerUtils.iAlert(data.error_info);  // 提示错误信息
			}

		},false,true,handleTimeout);
	}




	/**
	 * initDegree 选择初始化学历选择下拉框
	 * @param  {jQuery} $selector  jQuery选择器
	 * @param  {string} default_degree  已经存在的默认值
	 *
	 * 1.传入的默认值，会设置一个默认的学历数据
	 * 2.没有传入参数，则无默认学历数据
	 */
	function initDegree($selector,default_degree){

		var param = {"enum_type" : "adapter"};

		service.queryDataDict(param,function(data){
			layerUtils.iLoading(false);
			console.log(data);
			if(data.error_no=='0' && data.results){

				var select_str = '',
					adapter     = data.results;

				if(typeof default_degree == 'undefined'|| default_degree===''){
					select_str += '<option value="">请选择学历</option>';
				}

				for(var i= 0;i < adapter.length;i++){
					if(default_degree && default_degree == adapter[i]['item_value']){
						select_str+='<option selected="selected" value="'+adapter[i]['item_value']+'">'+adapter[i]['item_name']+'</option>';
					}else{
						select_str+='<option value="'+adapter[i]['item_value']+'">'+adapter[i]['item_name']+'</option>';
					}
				}
				$selector.html(select_str);
			}else{
				layerUtils.iAlert(data.error_info);
			}
		},false,true,handleTimeout);
	}

	/* 处理请求超时 */
	function handleTimeout(){
		layerUtils.iConfirm("请求超时，是否重新加载？",function(){
			initDegree();
			initOccupation();
			querySex();
		});
	}

	/**
	 * 获取年龄
	 * @param  {string} str  1988-10-01
	 * @param  {boolean} flag  是否含生日当天
	 * @return {int} 年龄
	 */
	 function getAge(str,flag){
 
         var Now        = new Date();
         var curYear    = Now.getFullYear();
         var curMonth   = Now.getMonth();
         var curDate    = Now.getDate();

         var Start      = new Date(str);
         var startYear  = Start.getFullYear();
         var startMonth = Start.getMonth();
         var startDate  = Start.getDate();

 		if(curMonth-startMonth > 0 || (curMonth-startMonth == 0 && curDate - startDate > 0)){
 			return curYear - startYear;
 		}else if(flag && curMonth-startMonth == 0 && curDate - startDate == 0){ //生日当天
 			return curYear - startYear;
 		}else{
 			return curYear - startYear-1;
 		}

     }

	/* 信息提交校验 */
	function verifyInfo(){

		var id_no                 = $(_pageId+" .id-no").val(),                             // 身份证号
			id_custname           = $(_pageId+" .id-name").val(),                           // 用户名
			id_native             = $(_pageId+" .id-addr").val().replace(/\s+/g,""),        // 证件地址
			id_recommendNo        = $(_pageId+" .id-recommendno").val(),                    // 推荐人号码
			id_postid             = $(_pageId+" .id-postcode").val(),                       // 邮政编码
			id_edu                = $(_pageId+" .id-degree").val(),                         // 学历代码
			id_professionCode     = $(_pageId+" .id-occup").val(),                          // 职业代码

			id_beginDate          = $(_pageId+" .id-begindate").val(),                    // 身份证起始日期
			id_endDate            = $(_pageId+" .id-enddate").val(),                      // 身份证有效期限
			id_policeorg          = INFO_PARAM['policeorg'];                                // 发证机关


		if(id_custname == ""){
			layerUtils.iAlert("您还没有输入姓名！");
			return false;
		}


		if(id_no == ""){
			layerUtils.iAlert("您还没有输入身份证号码！");
			return false;
		}

		if(!validateIdCard(id_no)){
			layerUtils.iAlert("您的身份证号码不对，请核对后重新输入！");
			return false;
		}

		if(new Date(id_endDate).getTime() - new Date().getTime() <= 0){
			layerUtils.iAlert("您的身份证已过期!");
			return false;
		}

		if(new Date(id_endDate).getTime() - new Date().getTime()-3*30*24*3600*1000 <= 0){
			layerUtils.iAlert("您的身份证有效期已不足3个月!");
			return false;
		}

		if(id_postid == ""){
			layerUtils.iAlert("邮政编码不能为空！");
			return false;
		}
		if(!validatorUtil.isPostalCode(id_postid)){
			layerUtils.iAlert("您输入的邮政编码有误，请重新输入！");
			return false;
		}

		if(id_native == ""){
			layerUtils.iAlert("您还没输入联系地址！");
			return false;
		}

		if(id_professionCode == ""){
			layerUtils.iAlert("您还没有选择您的职业信息！");
			return false;
		}

		if(id_edu == ""){
			layerUtils.iAlert("您还没有选择您的学历信息！");
			return false;
		}

		if(id_no.length == 18){ // 对不满 18或者大于70周岁的进行控制

			var birthday = id_no.substring(6,10)+"/"+id_no.substring(10,12)+"/"+id_no.substring(12,14);

			if(getAge(birthday,false) < 18){
				layerUtils.iAlert("您的年龄未满 18 周岁，请临柜开户!");
				return false;
			}

			if(getAge(birthday,true) >= 70){
				layerUtils.iAlert("您的年龄超过 70 周岁，请临柜开户或使用双向视频开户!");
				return false;
			}
		}


		//获取ORC读取的身份证号码
		var original_id_no = INFO_PARAM['idno'],
			diffCount      = 0;

		$.each(id_no,function(index){
			if(original_id_no[index] !== id_no[index]){
				diffCount ++;
			}
		});

		if(diffCount > 5){
			layerUtils.iConfirm(
				"发现您的证件号码与上传的差异过大，请您确认是否需要更换身份证",
				function(){appUtils.pageInit("account/personInfo","account/uploadPhoto");},
				function(){return false;},
				"重新上传",
				"重新确认"
			);
			return false;
		}

		return true;
	}


	//公安验证
	function identityRecognition(){
		var param = {
			"user_id"   : USER_ID,
			"mobile_no" : MOBILE_NO,
			"id_no"     : $(_pageId+" .id-no").val(),
			"user_name" : $(_pageId+" .id-name").val()
		}

		service.identityRecognition(param,function(data){
			layerUtils.iLoading(false);

			if(data.error_no == 0) {
	    		var policePhotoFlag = data.results[0].policePhotoFlag;
	    		if(policePhotoFlag=="1"){
	    			submitInfo();  //提交用户信息
	    		}else{
	    			layerUtils.iAlert("公安验证失败，请联系客服");
				}
	    	}else {
	    		layerUtils.iAlert(data.error_info);
	    	}
		});
	}


	function syncCustInfo(){
		var syncCustInfoParam = {
				user_id : USER_ID,
				"autentication_type" :global.isvideo=="1"?"1":"3"
			};

			service.syncCustInfo(syncCustInfoParam,function(data){
				layerUtils.iLoading(false);
				if(data.error_no == 0){

					appUtils.pageInit("account/personInfo","account/signProtocol");
				}else{

					layerUtils.iMsg(-1,error_info);
				}
			})
	}

	function cleanPageElement(){

	}

	function validateIdCard(idCard){
		//15位和18位身份证号码的正则表达式
		var regIdCard=/^(^[1-9]\d{7}((0\d)|(1[0-2]))(([0|1|2]\d)|3[0-1])\d{3}$)|(^[1-9]\d{5}[1-9]\d{3}((0\d)|(1[0-2]))(([0|1|2]\d)|3[0-1])((\d{4})|\d{3}[Xx])$)$/;

		//如果通过该验证，说明身份证格式正确，但准确性还需计算
		if(regIdCard.test(idCard)){
			if(idCard.length==18){
				var idCardWi=[7, 9, 10, 5, 8, 4, 2, 1, 6, 3, 7, 9, 10, 5, 8, 4, 2]; //将前17位加权因子保存在数组里
				var idCardY=[ 1, 0, 10, 9, 8, 7, 6, 5, 4, 3, 2 ]; //这是除以11后，可能产生的11位余数、验证码，也保存成数组
				var idCardWiSum=0;  //用来保存前17位各自乖以加权因子后的总和
				for(var i=0;i<17;i++){
					idCardWiSum+=idCard.substring(i,i+1)*idCardWi[i];
				}

				var idCardMod=idCardWiSum%11;//计算出校验码所在数组的位置
				var idCardLast=idCard.substring(17);//得到最后一位身份证号码

				//如果等于2，则说明校验码是10，身份证号码最后一位应该是X
				if(idCardMod==2){
					return idCardLast=="X"||idCardLast=="x";
				}else{
					//用计算出的验证码与最后一位身份证号码匹配，如果一致，说明通过，否则是无效的身份证号码
					return idCardLast==idCardY[idCardMod];
				}
			}
		}else{
			return false;
		}
	}


	var personInfo = {
		"init" : init,
		"bindPageEvent" : bindPageEvent,
		"pageBack" : pageBack,
		"destroy" : destroy
	};

	module.exports = personInfo;
});
