define(function(require,exports,module){
	/* 私有业务模块的全局变量 begin */
	var appUtils        = require("appUtils"),
		service         = require("serviceImp").getInstance(), //业务层接口，请求数据
		global          = require("gconfig").global,
		layerUtils      = require("layerUtils"),
		_pageId         = "#account_riskAssessment",
		USER_ID,
		QUESTION_AMOUNT = 0,
		TIME_OUT_ID;

	
	function init(){
		USER_ID       = appUtils.getSStorageInfo("user_id");
		initPage();
	}

	function initPage(){		
		getRiskAssessQuestions();  // 获取问卷答题
	}

	function bindPageEvent(){

		var $next  = $(_pageId+' .btn-next-step');

		appUtils.bindEvent($next,function(){

					var ans = verifyAnswer();

					if(ans){
						submitAnswer(ans);
					}
				});

			}

	function destroy(){
		$(_pageId).remove();
		service.destroy();
	}

	
	/* 获取风险测评题库并生成题目*/
	function getRiskAssessQuestions(){
		
		var queryTestParam = {"user_id":USER_ID};

		service.queryRiskToc(queryTestParam,function(data){
			

			if(data.error_no==0 && data.results){
				var results  = data.results,
					arr      = [],
					html_str = '';


				//按照题目id将数据排序
				results.sort(function(obj1,obj2){
					return obj1.que_id - obj2.que_id;
				});

				//将同一道题目的答题选项分成同一个组
				if(results.length == 1){
					arr.push({
						que_id :results[0]['que_id'],
						q_name :results[0]['q_name'],
						type:results[n]['type'],
						ans:results
					})
				}else{
					for(var i = 0,n = 0; i+1 < results.length; i++){

						if(results[i]['que_id'] != results[i + 1]['que_id']){

							arr.push({
								que_id :results[n]['que_id'],
								q_name :results[n]['q_name'],
								type:results[n]['type'],
								ans: results.slice(n,i+1)
							});

							n =i+1;

						}else if(i+2 == results.length){

							arr.push({
								que_id :results[n]['que_id'],
								q_name :results[n]['q_name'],
								type:results[n]['type'],
								ans: results.slice(n,i+2)
							});
						}
					}
				}

				QUESTION_AMOUNT = arr.length;

				for(var p = 0; p < arr.length ; p++){

					html_str+='<dl id="q-'+p+'" class="q-item">'+
							  	' <dt>'+(p+1)+'. '+arr[p]['q_name']+'('+(arr[p]['type']==0?'单选':'多选')+')</dt>';

					for(var q = 0;q<arr[p]['ans'].length;q++){
						html_str+='<dd><label><input name="q'+p+'" data-index="'+p+'" value="'+arr[p]['que_id']+'_'+arr[p]['ans'][q]['ans_id']+'_'+arr[p]['ans'][q]['mark']+'" type="radio"><span>'+arr[p]['ans'][q]['a_name']+'</span></label></dd>'
					}

					html_str+='</dl>';
				}

				
				//将题目显示在页面上
				$(_pageId+' .risk-test-question').html(html_str);

				bindQuestionEvent();

			}else{
				layerUtils.iAlert(data.error_info);
			}
		},true,true,handleTimeout);
	}

	function bindQuestionEvent(){
		appUtils.bindEvent('input',function(){
			var cur = $(this).attr('data-index');
			var next = Number(cur)+1;
			console.log(next);

			for (var i = next;i < QUESTION_AMOUNT; i++){

				if(!$('input[name=q'+i+']').is(':checked')){
					clearTimeout(TIME_OUT_ID);
					TIME_OUT_ID = setTimeout(function(){
						document.getElementById("q-"+i).scrollIntoView();
					},200);
					break;
				}
			}

			


		},'change');
	}







	/* 处理请求超时 */
	function handleTimeout(){
		layerUtils.iConfirm("请求超时，是否重新加载？",function(){
			getRiskAssessQuestions();  // 再次风险测评题目
		});
	}

	/**
	 * [verifyAnswer 检验问题答案]
	 * 1.如果验证失败 提示失败并返回 false
	 * 2.如果通过验证 则返回答案字符串
	 */
	function verifyAnswer(){
		var answered   = '',
			unanswered = '',
			v='';
		for(var i = 0;i<QUESTION_AMOUNT;i++){
			v = $(_pageId+' input[name=q'+i+']:checked').val();
			if(v){
				answered+= v+'|';
			}else{
				unanswered+=(i+1)+'、';
			}
		}

		if(unanswered){
			unanswered = unanswered.substring(0,unanswered.length-1);	//去掉最后一个'、'
			layerUtils.iAlert("您的答题尚未完成，未完成题目编号：["+unanswered+"]");
			
			var q = Number(unanswered.split('、').shift())-1;
			document.getElementById("q-"+q).scrollIntoView();
			return false;
		}

		return answered;

	}



	
	/**
	 * [submitAnswer 提交测评结果]
	 * @param  {string} keys 答案字符串  {que_id}_{ans_id}_{mark}|{que_id}_{ans_id}_{mark}|
	 */
	function submitAnswer(keys){

		var param ={
			"user_id":USER_ID,
			"sub_id":"1",
			"q_a_args":keys
		};

		// 提交风险评测答案
		service.submitTestAnswer(param,function(data){

			if(data.error_no==0 && data.results.length != 0){//调用成功,跳转到风险测评页面
				console.log(data);
				var risk_exp  = data.results[0].riskexp,
					risk_desc = data.results[0].riskdesc;

				appUtils.setSStorageInfo("risk_exp",risk_exp);
				appUtils.setSStorageInfo("risk_desc",risk_desc);

				appUtils.pageInit("account/riskAssessment","account/riskAssessmentResult",{risk_desc:risk_desc});
			}else{
				layerUtils.iAlert(data.error_info);
			}
		});
	}
	
	module.exports = {
		"init" : init,
		"bindPageEvent" : bindPageEvent,
		"destroy" : destroy
	};
});