define(function(require,exports,module){

	var appUtils   = require("appUtils"),
		global     = require("gconfig").global,
		_pageId    = "#account_riskAssessmentResult",
		RISK_EXP,
		RISK_DESC;
	
	function init(){

		RISK_EXP  = appUtils.getSStorageInfo("risk_exp");  //1-低风险 2-中风险 3-高风险
		RISK_DESC = appUtils.getSStorageInfo("risk_desc");


		var $type  = $(_pageId+' .type'),
			$tips  = $(_pageId+' .tips'),
			$img   = $(_pageId+' img');

		var level ={
			    '1':{
			        img_url:'images/risk_1.png',
			        desc:'<p>雷不动&nbsp;&nbsp;打不动</p><p>别人咋劝都没用</p>'
			    },
			    '2':{
			        img_url:'images/risk_2.png',
			        desc:'<p>黄叶落&nbsp;&nbsp;白云扫</p><p>稳健安全才最好</p>'
			    },
			    '3':{
			        img_url:'images/risk_3.png',
			        desc:'<p>书山路&nbsp;&nbsp;勤为径</p><p>循序渐进齐头进</p>'
			    }
			}


		$type.text(RISK_DESC);
		$tips.html(level[RISK_EXP]['desc']);
		
		var img = new Image();
		img.src=level[RISK_EXP]['img_url'];

		img.onload = function(){
			$img.attr('src',level[RISK_EXP]['img_url']);
		}

	}
	

	function bindPageEvent()
	{
		var $retest = $(_pageId+' .re-test'),
			$next   = $(_pageId+' .btn-next-step');

		// 重新测评绑定事件
		appUtils.bindEvent($retest,function(e){
			e.preventDefault();
			appUtils.pageInit("account/riskAssessmentResult","account/riskAssessment");
		});

		//下一步
		appUtils.bindEvent($next,function(){
			appUtils.pageInit("account/riskAssessment","account/openConfirm");
	   });

	}
	
	function destroy(){
		
	}
	
	var riskAssessmentResult = {
		"init" : init,
		"bindPageEvent" : bindPageEvent,
		"destroy" : destroy
	};
	
	module.exports = riskAssessmentResult;
});