/**
 * 查看数字证书的协议
 */
define(function(require, exports, module){ 

	var appUtils    = require("appUtils"),
		service     = require("serviceImp").getInstance(),  //业务层接口，请求数据
		global      = require("gconfig").global,
		layerUtils  = require("layerUtils"),
		_pageId     = "#account_showDigitalProtocol";
	
	function init(){

		var protocolId = appUtils.getPageParam("protocolId");
		queryProtocolText(protocolId);
	}
	
	function bindPageEvent(){
		appUtils.bindEvent($(_pageId+" .btn-next-step"),function(){
			appUtils.pageBack();
		});
	}
	
	function destroy(){

		// 将协议内容置空
		$(_pageId+' .protocol-title').text('');
		$(_pageId+' .protocol-content').html('');
		service.destroy();
	}
	
	/*获取协议内容*/
	function queryProtocolText(protocolId){
		// 查询证书内容
		var param = {
				"econtract_no" : protocolId,
				"econtract_version":""
		};

		$protocol_title   = $(_pageId+' .protocol-title');
		$protocol_content = $(_pageId+' .protocol-content');

		service.getProtocolInfo(param,function(data){
			console.log(data);

			if(data.error_no == "0"){
				
				$protocol_title.text(data.results[0].econtract_name);      // 设置协议标题
				$protocol_content.html(data.results[0].econtract_content); // 协议内容

				if(param.econtract_no === "8001"){
					$(".rich_media_meta_list", _pageId).remove();
					$(".rich_media_title", _pageId).css({
                        "font-size" : "18px",
                        "text-align" : "center"
                    });
					$(".info_titbox", _pageId).remove();
				}

			}else{
				layerUtils.iAlert(data.error_no);
			}
		})
	}

	// 暴露对外的接口
	module.exports = {
		"init" : init,
		"bindPageEvent" : bindPageEvent,
		"destroy" : destroy
	};
});