/**
 * 视频见证注意事项
 */
define(function(require, exports, module){ 

    var appUtils     = require("appUtils"),
        service      = require("serviceImp").getInstance(),
        gconfig      = require("gconfig"),
        layerUtils   = require("layerUtils"),
        _pageId      = "#account_success";

    var BRANCH_NAME,
        USER_ID,
        MOBILE_NO;

	
	function init(){

        USER_ID      = appUtils.getSStorageInfo("user_id"),
        MOBILE_NO    = appUtils.getSStorageInfo("mobileNo");

        var $status       = $(_pageId+' .result-status'),          // 状态
            $pending      = $(_pageId+' .result-pending'),         // 等待中
            $success      = $(_pageId+' .result-success'),         // 成功
            $success_desc = $(_pageId+' .result-success-desc'),    // 成功状态
            $fail         = $(_pageId+' .result-fail');            // 失败
            $mobile_no    = $(_pageId+' #mobile-no');

        $mobile_no.text(MOBILE_NO.slice(0,3)+'****'+MOBILE_NO.slice(7,11)); //显示手机号 

        var param = {
            "user_id" : USER_ID
        };
        service.queryUserInfo(param,function(data){


            if(data.error_no === "0"){
                var results = data.results[0];

                var fund_account = results.fund_account, //资金账号
                    shaselect    = results.shaselect,    //是否选择沪A
                    szaselect    = results.szaselect,    //是否选择深A
                    shaaccount   = results.shaaccount,   //沪A账号
                    szaaccount   = results.szaaccount;   //深A账号

                /**
                 * 开通成功的条件
                 * 1.资金账户开通
                 * 2.沪A和深圳A必须选择了一个
                 * 2.如果选择了沪A 则 沪A开通
                 * 3.如果选择了深A 则 深A开通
                 */ 
                if(fund_account && (shaselect == 2 || szaselect == 2) && (shaselect == 2 ? shaaccount : true ) && (szaselect == 2 ? szaaccount : true )){
                    
                    var html =  '<table>'+
                                    '<tr><td>资金账户</td><td><strong>'+ fund_account +'</strong></td></tr>'+
                                    (shaselect == 2 ? ('<tr><td>沪A股东账户</td><td><strong>'+ shaaccount +'</strong></td></tr>'):'')+
                                    (szaselect == 2 ? ('<tr><td>深A股东账户</td><td><strong>'+ szaaccount +'</strong></td></tr>'):'')+
                                '</table>';

                    $success_desc.html(html);
                    $status.removeClass('fail').addClass('success');
                    $pending.hide();
                    $success.show();
                    return;
                }


                $pending.show(); //等待中


            }else{
                layerUtils.iMsg(-1, data.error_info);
            }
        });
	}

    function bindPageEvent (){
        var $refresh_status = $(_pageId+' .refresh-status');
        // 刷新状态
        appUtils.bindEvent($refresh_status,function(e){
            e.preventDefault();
            init();
        });

    }
	
	function destroy(){
		service.destroy();
	}
	

	module.exports = {
        "init" : init,
        "bindPageEvent" : bindPageEvent,
        "destroy" : destroy
    };

});