/**
 * 视频见证注意事项
 */
define(function(require, exports, module){ 
	/* 私有业务模块的全局变量 begin */
	var appUtils = require("appUtils"),
	      service = require("serviceImp").getInstance(),  //业务层接口，请求数据
		  gconfig = require("gconfig"),
		  global = gconfig.global,
		  layerUtils = require("layerUtils"),
		  needVideo = "",
		  _pageId = "#account_videoNotice";
	/* 私有业务模块的全局变量 end */
	
	function init()
	{
		window.imgState = imgState;  // 照片上传完成后自动调用该方法
		window.videoOfflineSuccess = videoOfflineSuccess;  // 见证成功
	    initPage();  // 初始化页面
//		getVedioport();  // 获取营业部视频端口
	}
	
	function videoOfflineSuccess(){
		aginSubmitVideo();
	}
	
	function offLineVideoApply(){
		//修改用户当前视频方式
		var param = {
			"user_id" : appUtils.getSStorageInfo("user_id"),
			"witness_way" : "1"   //当前为单向视频
		};
		service.changeMethod(param,function(data) {
			var error_no = data.error_no;
			var error_info = data.error_info;
			var result = data.results;
			var similarity = result[0].similarity;
			var pass_flag = result[0].pass_flag;
//			var pass_flag = "0";
			if (pass_flag == "1") {
				var param = {
					"user_id" : appUtils.getSStorageInfo("user_id"),
					"user_name" : appUtils.getSStorageInfo("custname"),
					"shortestTime":"5",  //录制最短时间  单位秒
					"longestTime":"15",  //录制最长时间  单位秒
					"jsessionid": appUtils.getSStorageInfo("jsessionid"),  
					"videoUrl" : global.serverPath
				};
				require("shellPlugin").callShellMethod("videoWitnessOffLinePlugin",null,null,param);
			}else if (pass_flag == "0") {
				// 相机上传的参数
				var paiConfig = {
					"funcNo" : "501526" ,
					"uuid" : "index",
					"r" : Math.random(),
					"user_id" : appUtils.getSStorageInfo("user_id"),
					"phototype" : "人像正面" ,	// 影像名称
					"action" : "pai",	// 照片来源类别，phone 相册，pai 相机
					"img_type" : "3",
					"key" : "index",	// key 和 uuid 只需要写一个
					"url" : global.serverPath,
					"id_no" : appUtils.getSStorageInfo("idCardNo"), //身份证号
					"clientinfo" : appUtils.getSStorageInfo("clientinfo"), 	// 从 session 中将 clientinfo 取出
					"jsessionid" : appUtils.getSStorageInfo("jsessionid")	// 从 session 中将 jsessionid 取出
				};
				require("shellPlugin").callShellMethod("faceRecognitionPlugin",null,null,paiConfig);
			}
		});
	}
	
	function bindPageEvent()
	{
		/* 绑定返回 */
		appUtils.bindEvent($(_pageId+" .header .icon_back"),function(){
			pageBack();
		});
		
		/* 重新上传照片 */
		appUtils.bindEvent($(_pageId+" .photo_again"),function(){
			var param = {
				user_id : appUtils.getSStorageInfo("user_id"),
				lastcomplete_step : "0", 
				opacctkind_flag : ""  
			};
			service.queryChangeState(param,function(data){
				var error_no = data.error_no;
				var error_info = data.error_info;
				if(error_no == 0)
				{
					appUtils.setSStorageInfo("idInfo","exist");
					appUtils.pageInit("account/videoNotice","account/uploadPhoto",{});
				}
				else
				{
					layerUtils.iLoading(false);
					layerUtils.iMsg(-1,error_info); 
				}
			});
		});
		
		/* 重新提交资料 */
		appUtils.bindEvent($(_pageId+" .info_again"),function(){
			var Flag = false;
			var currentStep = appUtils.getSStorageInfo("currentStep");
			if(currentStep == "uploadimg" || currentStep == null)
			{
				Flag = true;
			}
			else
			{
				Flag = false;
			}
			var param = {
				user_id : appUtils.getSStorageInfo("user_id"),
				lastcomplete_step : "uploadimg", 
				opacctkind_flag : ""  
			};
			service.queryChangeState(param,function(data){
				var error_no = data.error_no;
				var error_info = data.error_info;
				if(error_no == 0)
				{
					pageBack();
				}
				else
				{
					layerUtils.iLoading(false);
					layerUtils.iMsg(-1,error_info); 
				}
			}, Flag);
		});
		
		/* 申请QQ预约 */
		appUtils.bindEvent($(_pageId+" .c_link"),function(){
			appUtils.pageInit("account/videoNotice","account/orderQq",{});
		});
		
		/* 在线视频视频见证 */
		appUtils.bindEvent($(_pageId+" .ct_btn:eq(0)"),function(){
			offLineVideoApply();
		});
	}
	
	//人脸识别上传照片成功
	function imgState(pass_flag, similarity, base64, pass_similarity) {
		var base64Str = base64.replace(/[\n\r]*/g,"");
		var pass_flag = pass_flag;
		var similarity = similarity;
		var pass_similarity = pass_similarity;
		appUtils.setSStorageInfo("base64Str",base64Str);
		appUtils.setSStorageInfo("pass_flag",pass_flag);
		appUtils.setSStorageInfo("similarity",similarity);
		appUtils.setSStorageInfo("pass_similarity",pass_similarity);
		//是否通过的配置 1代表通过  0代表不通过
		if(pass_flag == 1)
		{
			appUtils.pageInit("account/videoNotice","account/videoNotice",{});
			$(_pageId+" .ct_btn:eq(0) a").html("开始录制");
			$(_pageId+" .top_title:eq(0)").show();
//			$(_pageId+" .top_title").html("人脸识别成功！单向视频见证前准备请做好如下准备，并录制视频过程中，请根据提示回答问题。");
		} else if (pass_flag == "0") {
			layerUtils.iAlert("人脸识别失败，请点击确定进行下一步...", 0, function(){
				appUtils.pageInit("account/videoNotice","account/videoNotice",{});
			}, "确认");
		}
	}

	
	function destroy()
	{
		// 页面初始化样式重置
		$(_pageId+" .header h3:eq(0)").show();
		$(_pageId+" .header h3:eq(1)").hide();
		$(_pageId+" .error_notice:eq(0)").hide();
		$(_pageId+" .error_notice:eq(1)").hide();
		$(_pageId+" .camera_notice:eq(0)").show();
		$(_pageId+" .camera_notice:eq(1)").hide();
		$(_pageId+" .photo_again").hide();
		$(_pageId+" .info_again").hide();
		$(_pageId+" .c_link").show();
		$(_pageId+" .ct_btn:eq(0)").show();
		$(_pageId+" .ct_btn:eq(1)").hide();
		service.destroy();
	}
	
	
	/* 处理返回按钮 */
	function pageBack()
	{
		var currentStep = appUtils.getSStorageInfo("currentStep");
		// 从短信登陆进入(当前完成步骤为：已提交资料)，处理返回按钮
		if(currentStep == "idconfirm")
		{
			appUtils.setSStorageInfo("currentStep","uploadimg");
			appUtils.setSStorageInfo("personInfo","exist");  // 标记完成资料填写步骤
			appUtils.pageInit("account/videoNotice","account/personInfo",{});
		}
		// 从短信登陆进入，在personInfo提交资料后，处理返回按钮
		else if(appUtils.getSStorageInfo("currentStep") == "uploadimg")
		{
			appUtils.setSStorageInfo("personInfo","exist");  // 标记完成资料填写步骤
			appUtils.pageBack();
		}
		// 正常开户流程处理返回按钮
		else
		{
			appUtils.pageBack();
		}
	}
	
	/* 初始化页面 */
	function initPage()
	{
		var videoParam = appUtils.getSStorageInfo("videoParam");
		if(videoParam!=""&&videoParam!=null&&videoParam!=undefined)
		{
			videoParam = JSON.parse(videoParam);
			needVideo = videoParam.need_video;
		  if(needVideo == 1)
		  {
			$(_pageId+" .main .error_notice:eq(1)").show();
		  }
		}
	}
	
	/* 获取营业部视频端口 */
	function getVedioport()
	{
		if(appUtils.getSStorageInfo("_prePageCode") == "account/msgVerify")
		{
			 queryQQOfflineState();  // 查询视频通过状态
		}else{
			layerUtils.iLoading(false);  //关闭等待层
		}
	}
	
	/* 处理请求超时 */
	/*function handleTimeout()
	{
		layerUtils.iConfirm("请求超时，是否重新加载？",function(){
			getVedioport();  // 再次获取视频端口
		});
	}*/
	
	/* 查询离线视频通过状态 */
	function queryQQOfflineState()
	{
		var lookVedioStateParam = {
			"user_id" : appUtils.getSStorageInfo("user_id")
		};
		service.queryQQOfflineState(lookVedioStateParam,function(data){
			var error_no = data.error_no;
			var error_info = data.error_info;
			if(error_no == 0 && data.results.length != 0)
			{
				// 视频通过状态，0：未见证、2：已预约离线见证未完成见证、1：视频见证完成、3：见证失败
				// 未见证不需要做处理
				var witnessFlag = data.results[0].witness_flag;
				if(witnessFlag == 1)
				{
					var time = new Date().format("yyyy-MM-dd HH:mm:ss");
			 		var stepParam = {"user_id" :appUtils.getSStorageInfo("user_id"),"sub_id":null,"q_a_args":null};
					appUtils.pageInit("account/videoNotice","account/openConfirm",{});
				}
				else if(witnessFlag == 2)
				{
					layerUtils.iAlert("您的预约信息已经提交，我们的客服将尽快联系您！",0);
				}
				else if(witnessFlag == 3)
				{
					$(_pageId+" .c_link").show();
					$(_pageId+" .ct_btn:eq(0)").show();
					$(_pageId+" .ct_btn:eq(1)").hide();
					layerUtils.iAlert("视频见证失败，请重新申请见证！");
				}
				else if(witnessFlag == 4)
				{
					layerUtils.iAlert("资料审核中，工作人员会尽快给您回复，请耐心等候！");
				}
			}
			else
			{
				layerUtils.iAlert(data.error_info);
			}
		});
	}
	
	/* 重新提交视频  */
	function aginSubmitVideo()
	{
		
		//如果视频被驳回
		if(needVideo == 1){
			//调用提交补全资料接口
		var param = {
			"userid" : appUtils.getSStorageInfo("user_id",true),
			"fieldname" : "video_one"  
		};
			service.rejectStep(param,function(data){
				if(data.error_no == 0)
				{
					appUtils.setSStorageInfo("isBack", "backInfo");  //标志重新提交资料成功
					appUtils.pageInit("account/videoNotice","account/accountResult",{});
				}
			});
		}
		else{
			queryQQOfflineState();  // 查询视频通过状态
		}
	}
	
	/* 见证不通过 */
	function videoFail(){}
	
	/* 见证被驳回 */
	function videoReject()
	{
		$(_pageId+" .header h3:eq(0)").hide();
		$(_pageId+" .header h3:eq(1)").show();
		$(_pageId+" .error_notice:eq(0)").hide();
		$(_pageId+" .error_notice:eq(1)").show();
		$(_pageId+" .camera_notice:eq(0)").hide();
		$(_pageId+" .camera_notice:eq(1)").show();
		$(_pageId+" .photo_again").show();
		$(_pageId+" .info_again").show();
		$(_pageId+" .c_link").hide();
		$(_pageId+" .fix_bot").hide();
	}
	
	/* QQ预约 */
	function qqApplay()
	{
		appUtils.pageInit("account/videoNotice","account/orderQq",{});
	}

	var videoNotice = {
		"init" : init,
		"bindPageEvent" : bindPageEvent,
		"pageBack" : pageBack,
		"destroy" : destroy
	};
	
	// 暴露对外的接口
	module.exports = videoNotice;
});