/**
 * 微信开户中转页
 */
define(function(require, exports, module){
	/* 私有业务模块的全局变量 begin */
	var appUtils      = require("appUtils"),
		service       = require("serviceImp").getInstance(),  //业务层接口，请求数据
		global        = require("gconfig").global,
		layerUtils    = require("layerUtils"),
		external      = require("external"),
		IS_SDK        = global.is_sdk,
		INTERVAL      = 0,
		RANDOM        = "0000",                //随机数
		NULL_COUNT,                             //0 =初始化、-1=上传中、-2=成功、大于0=失败次数
		_pageId       = "#account_videoRecord";

	var	USER_ID,
		VIDEO_UPLOADED,
		REJECT_STEP,  //判定是否为驳回重新上传
		JSESSIONID;

	require("videoupload");

	/* 私有业务模块的全局变量 end */


	function init() {
		USER_ID        = appUtils.getSStorageInfo("user_id");
		CUSTNAME       = appUtils.getSStorageInfo('custname');
		VIDEO_UPLOADED = appUtils.getSStorageInfo("videoUploaded");
		REJECT_STEP    = appUtils.getSStorageInfo("rejectStep");  //判定是否为驳回重新上传
		JSESSIONID     = appUtils.getSStorageInfo("jsessionid");

	    initPage();
	}

	function initPage() {

	    REJECT_STEP = JSON.parse(REJECT_STEP);

	    RANDOM     = (Math.random() + "").replace(/\d+?\.(\d{4})\d+/, "$1");
	    $(_pageId + " .number span").html(RANDOM);

	    if (VIDEO_UPLOADED == "1" && !REJECT_STEP.backPostConfirm) {

	        //上传视频成功后非驳回不能返回重新上传视频
	        appUtils.pageInit("account/videoRecord", "account/success");
	        return false;
	    }

	    showshadowWait(false, 0);
	}

	function bindPageEvent() {

		var $next = $(_pageId + " .btn-next-step")

	    appUtils.bindEvent($next, function() {

			layerUtils.iConfirm(
				'请不要戴帽子或者眼镜，在光线良好条件下正对摄像头，录制3-10秒视频，计时开始后，匀速朗读一遍<h2 style="font-size:30px;text-align:center;padding-top:10px;color:#f35833;">' + RANDOM + '</h2>',
				startRecord,
				function(){return;},
				"开始录制",
				"取消"
			);
	    });
	}

	function startRecord(){

        if(IS_SDK){ //sdk上传
        	recordVideoByShell();
            return;
        }

        $(_pageId + " #record_file").remove();
        $(_pageId).append('<input type="file" name="record_file" id="record_file" accept="video/*" capture="camcorder" style="width:0px;height:0px;display:none;">');

		var fileid = getRandomStr(6);
		var url    = global.serverUrl+"/servlet/VideoRecordAction;jsessionid="+JSESSIONID+"?function=upload&fileid="+fileid+"&random="+RANDOM+"&user_id="+USER_ID;

		var handleBefore  = function(){
								showshadowWait(true,0);
							    NULL_COUNT = 0;
							    clearInterval(INTERVAL);
		                	};

		var handleChange  = function(callback){
								if(callback){callback();}
							};

		var handleSuccess = function(data,state){
								NULL_COUNT = 0;
								layerUtils.iLoading(false);
								if(data.error_no==0){
									clearInterval(INTERVAL);

									$(_pageId+" .progressBar a").animate({"width" : "100%"}, 200);

									if($(_pageId+" .ly_shadow .s3").css("display")=="none"){
										showshadowWait(true,1);
									}

									setTimeout(function(){
										showshadowWait(true,1);
										submitPostApply();
									},2000);
								}else{
									clearInterval(INTERVAL);
									showshadowWait(false,0);
									if(data.error_no == "-6"){
										layerUtils.iAlert("对不起，您录制的视频文件过大，请控制录制时间在3-10秒之间");
									}else if(data.error_no == "-7"){
										layerUtils.iAlert("对不起，您录制的视频太小，请录制至少3秒以上的视频-10秒之间");
									}else{
										layerUtils.iAlert(data.error_info);
									}
								}
							};
		var handleError =  function(obj,state,e){
								clearInterval(INTERVAL);
					    		layerUtils.iLoading(false);
					    		showshadowWait(false,0);

					    		if(state=="6"){
					    			layerUtils.iAlert("对不起，您录制的视频文件过大，请控制录制时间在3-10秒之间");
					    		}else if(state == "7"){
					    			layerUtils.iAlert("对不起，您录制的视频太小，请录制至少3秒以上的视频");
					    		}else if(state=="10"){
					    			layerUtils.iAlert("对不起，不能选择事先录制好的视频，请重新录制上传");
					    		}
							};

		var handleAfter  = function(){
								INTERVAL = setInterval(function(){
									queryProgressState(fileid);
								},1000);
							};

		var handleComplete =  function(){
								clearInterval(INTERVAL);
							};

		$("#record_file").uploadVideo({
					url           : url,
					secureuri     : true,
					type          : "POST",
					dataType      : "json",
					data          : {},
					maxsize       : global.maxsize || 20480,//20M
					minsize       : global.minsize || 300,
					immediate     : false,//是否校验相册文件
					fileElementId :"record_file",

					before        : handleBefore,
					change        : handleChange,
					success       : handleSuccess,
					error         : handleError,
					after         : handleAfter,
					complete      : handleComplete
				});
        $(_pageId + " #record_file").attr('currenttime', new Date().getTime()).trigger("click");
	}




	function queryProgressState(fileid) {

	    appUtils.invokeServer(global.serverUrl + "/servlet/VideoRecordAction;jsessionid="+JSESSIONID, {
	        "function"   : "progress",
	        "fileid"     : fileid,
	        "jsessionid" : JSESSIONID
	    }, function(data) {
	    	console.log(data);

	    	if(data.error_no.toString() !=="0"){
	            if (NULL_COUNT >= 20) {
	                showshadowWait(false, 0);
	                layerUtils.iAlert("查询失败", 0);
	                clearInterval(INTERVAL);
	            }
	            NULL_COUNT++;

	            return;
	    	}

            var result     = data.results[0],
            	totalsize  = result.totalsize || 1,
            	uploadsize = result.uploadsize || 1,
            	starttime  = result.starttime || 1,
            	endtime    = result.endtime || 1,
            	progress   = getProgress(totalsize, uploadsize, starttime, endtime);

            showshadowWait(true, 0);

            $(_pageId + " .up_jdbox .progressBar b").animate({"width": progress.percent + "%"}, 200);
            $(_pageId + " .up_jdbox .precent").html(progress.percent + "%");
            $(_pageId + " .up_jdbox .totalsize").html(progress.totalsize);
            $(_pageId + " .up_jdbox .speed").html(progress.speed);



            if (progress.percent > 99.9) {
                clearInterval(INTERVAL);
                showshadowWait(true, 1);
            }
	    }, false, true, false);
	}


	function getProgress(totalsize,uploadsize,starttime,endtime){

		var progress = {};

		progress.totalsize = totalsize /1048576;
		progress.percent   =  (uploadsize /totalsize) *100 ;
		progress.speed     = (uploadsize /((endtime-starttime)/1000)) /1024 ;
		progress.totalsize = (progress.totalsize+"").replace(/^(\d+?\.\d{2})\d*$/,"$1")+"MB";
		progress.percent   = (progress.percent+"").replace(/^(\d+?\.\d{2})\d*$/,"$1") ;
		progress.speed     = (progress.speed+"").replace(/^(\d+?\.\d{2})\d*$/,"$1")+"KB/s";
		console.log(progress);
		return progress;
	}




	function destroy(){
		$(_pageId).remove();
		service.destroy();
	}


	// 获取随机十六进制数字(指定长度)的字符串
	function getRandomStr(length) {
	    var str = "";
	    for (var i = 0; i < length; i++) {
	        str += Math.floor(Math.random() * 16).toString(16);
	    }
	    return str;
	}


	function clearFileListener() {//取消监听器
		clearInterval(INTERVAL);
	}


	/**
	 * recordVideoByShell 调用原生上传视频
	 */
	function recordVideoByShell(){
		// 相机上传的参数
		var param = {
			"strContent"        : RANDOM,
			"userId"            : USER_ID,
			"userName"          : CUSTNAME,
			"jsessionId"        : JSESSIONID,
			"shortestTime"      : "3", //录制最短时间  单位秒
			"longestTime"       : "20", //录制最长时间  单位秒
			"autenticationType" : "1",
			"uploadType"        : 0, //视频是否上云，1上云  0不上（默认）
			"url"               : global.serverPath + ";jsessionid=" + JSESSIONID,
			"funcNo"            : "60006",
			"moduleName"        : "open"
		};
		external.callMessage(param);
	}

	/**
	 * videoOfflineSuccess 调用原生上传视频成功后的回调
	 */
	function videoOfflineSuccess(data) {
		submitPostApply();
	}

	/**
	 * 功能：显示上传状态
	 * @param isWait 是否显示
	 * @param num  显示第几个 layer_box
	 */
	function showshadowWait(isWait,num){
		if(isWait){
			 $(_pageId+" .ly_shadow").show();
			 if(typeof(num)!=undefined){
				 $(_pageId+" .ly_shadow .layer_box").hide();
				 $(_pageId+" .ly_shadow .layer_box").eq(num).show();
			 }
		}else{
			$(_pageId+" .ly_shadow").hide();
			$(_pageId+" .ly_shadow .layer_box").hide();
			$(_pageId+" .ly_shadow .s1 .totalsize").html("0M");
			$(_pageId+" .ly_shadow .s1 .speed").html("0kb/s");
			$(_pageId+" .ly_shadow .s1 .precent").html("0%");
			$(_pageId+" .ly_shadow .s1 .progressBar b").css({"width":"0%"});
		}
	}


	/**
	 *  提交姿势识别申请
	 */
	function submitPostApply() {

		service.submitPostApply({
			"user_id":USER_ID
		},function(data){
			layerUtils.iLoading(false);

			if(!data || data.error_no!=="0"){
				layerUtils.iAlert(data.error_info);
				return;
			}

			appUtils.setSStorageInfo("need_action_face_reason","0");
			appUtils.setSStorageInfo("current_step","witness");
			appUtils.setSStorageInfo("videoUploaded","1");

			if(REJECT_STEP.backPostConfirm == 1){          //驳回重新上传的
				var notifyParam = {
					"user_id"             : USER_ID,
					"fieldname"           : "video_one",  // 通知视频已补全
					"laststep_is_witness" : "1"
				};
				service.rejectStep(notifyParam, function(data){
					if(data.error_no === "0"){
						appUtils.pageInit("account/videoRecord","account/success");       //返回结果页
					}
				});
			}else{
				appUtils.pageInit("account/videoRecord","account/success");
			}

		},true,true);
	}


	// 暴露对外的接口
	module.exports = {
		"init" : init,
		"bindPageEvent" : bindPageEvent,
		"destroy" : destroy,
		"videoOfflineSuccess": videoOfflineSuccess
	};
});
